#define ACCL 0.006   // Deceleration due to board coin friction
#define rs 0.75      //radius of striker
#define rg 0.5       //radius of gits  
#define MS 1         //Mass of the striker
#define MG 1         //Mass of the gits
#define total_gits 20 
#define powfact 0.05    // used to calculate power
#define pi 3.14159265
#define E 0.85        //Coefficient of restitution


#include "ezwin.h"
#include <cassert>
#include <cmath>
#include <iostream>
#include <cstring>
#include "Alert.h"

using namespace std;

//Declaring windows
SimpleWindow Start("Game",28.0,21.0, Position(0.5,0.5));
SimpleWindow W("CARROM", 28.0, 21, Position(0.5, 0.5));
SimpleWindow Help("Instrcutions", 28.0, 21, Position(0.5, 0.5));

//Declaring the required variables
int i,  //loop variable
k=0,	//different values of k lead to different actions on mouse click
disp=1,	//1:display can be modified.  0: Display is locked and cannot be modified
valid,	//used for validity of input
collisions=0,	//no. of collisions that have taken place
validpos=0,	//whether a valid position has been input
queen=0,	//1:queen was pocketed in the last chance   0:opposite
tobeSet=-1,     //index of the git to be set
cp=0,	// current player 0: Player 1    1:Player 2
due=0;  //1:There was a due in this chance


float r, //variable for different radii
len=0;   //0:Player 1   17:Player 2
float x[total_gits+1],y[total_gits+1],vx[total_gits+1],vy[total_gits+1]; //arrays that store x,y,velocity along x and velocity along y of all the coins
									 //0:striker 1:queen 2-10:white coins 11-19:black coins
float xm,ym,dist,b,vel,cvspx,cvspy;	// xm,ym = x,y of mouse   dist= distance between centres of colliding coins  b=angle in radians  vel=vel of striker as inputted by the user   cvspx,cvspy= currently valid striker position
float ccx=-10,ccy=-10;   // ccx,ccy = currently colliding coin's position

//function declarations
void Carrom_Display();
void Move();
int Collision();
void Instruct();
void Loading();
void Game();
void checkstop();
void chkdirection();
void chkoverlap();
void Set(int k);

int start_game(const Position &);
int Input(const Position &);
int help_game(const Position &);

int possess[2][total_gits+1],this_turn[total_gits+1];	//possess is 2D array which sores whether a player possesses a coin(1) or not(0)
							//this turn stores indices of all the coins that were pocketed in the current turn
int ApiMain()
{
	for(i=0;i<=total_gits;i++)	//set all possessions to zero
	{
		possess[0][i]=possess[1][i]=0;
	}
	
	Start.Open();	//Open Start window
	Game();
	Start.SetMouseClickCallback(start_game);
	return 0;
}


int start_game(const Position &P)
{
	xm=P.GetXDistance();
	ym=P.GetYDistance();

	if(xm>=9.4 && xm<=17.2 && ym>=5.4 && ym<=7.2)	//If there is a click inside start game box
	{
		Start.Close();	//Close previous window
		W.Open();	//Open new window
		Loading();	//Show the loading bar

		x[0]=10.5;	y[0]=2.0;	//Initial Striker position

	//Initial arrangement of coins
		//Arrangement for testing
		x[1]=10.5;    			y[1]=10.5;

		x[2]=10.5+2*rg*cos(pi/3);    	y[2]=10.5+2*rg*sin(pi/3);
		x[3]=10.5+2*rg*cos(pi/3);    	y[3]=10.5-2*rg*sin(pi/3);
		x[4]=10.5-2*rg;    		y[4]=10.5;
		x[5]=10.5-2*rg*cos(pi/3);    	y[5]=10.5-2*rg*sin(pi/3);
		x[6]=10.5-2*rg*cos(pi/3);    	y[6]=10.5+2*rg*sin(pi/3);
		x[7]=10.5+2*rg;    		y[7]=10.5;

		/*	All 19 coins	
		
		x[2]=10.5+2*rg*cos(pi/3);    	y[2]=10.5+2*rg*sin(pi/3);
		x[3]=10.5+2*rg*cos(pi/3);    	y[3]=10.5-2*rg*sin(pi/3);
		x[4]=10.5-2*rg;    		y[4]=10.5;
		x[5]=10.5+4*rg;    		y[5]=10.5;
		x[6]=10.5-4*rg;    		y[6]=10.5;
		x[7]=10.5+2*rg*sin(pi/3);    	y[7]=10.5+2*rg*(1+cos(pi/3));
		x[8]=10.5-2*rg*sin(pi/3);    	y[8]=10.5+2*rg*(1+cos(pi/3));
		x[9]=10.5+2*rg*sin(pi/3);    	y[9]=10.5-2*rg*(1+cos(pi/3));
		x[10]=10.5-2*rg*sin(pi/3);    	y[10]=10.5-2*rg*(1+cos(pi/3));
		
		x[11]=10.5-2*rg*cos(pi/3);    	y[11]=10.5-2*rg*sin(pi/3);
		x[12]=10.5-2*rg*cos(pi/3);    	y[12]=10.5+2*rg*sin(pi/3);
		x[13]=10.5+2*rg;    		y[13]=10.5;
		x[14]=10.5;    			y[14]=10.5-4*rg*sin(pi/3);
		x[15]=10.5;    			y[15]=10.5+4*rg*sin(pi/3);
		x[16]=10.5+2*rg*(1+cos(pi/3));  y[16]=10.5-2*rg*sin(pi/3);
		x[17]=10.5+2*rg*(1+cos(pi/3));  y[17]=10.5+2*rg*sin(pi/3);
		x[18]=10.5-2*rg*(1+cos(pi/3));  y[18]=10.5-2*rg*sin(pi/3);
		x[19]=10.5-2*rg*(1+cos(pi/3));  y[19]=10.5+2*rg*sin(pi/3);
		*/

		/*	Another arrangement for testing

		for(i=2;(i/2)<=total_gits;i+=2)
		{
			x[i/2]=i+2;
			y[i/2]=6.0;
			vx[i/2]=0;
			vy[i/2]=0;
		}
		*/

		Carrom_Display();
		W.Message("Player 1's turn");
		W.SetMouseClickCallback(Input);
	}

	else if(xm>=9.4 && xm<=17.2 && ym>=8.4 && ym<=10.2)	//If there is a click inside help box
	{
		Start.Close();
		Help.Open();
		Instruct();
		Help.SetMouseClickCallback(help_game);
	}

	else if(xm>=9.4 && xm<=17.2 && ym>=11.4 && ym<=13.2)	//if there is a click inside Exit box
		Start.Close();

	return 1;
}


int help_game(const Position &P)
{
	xm=P.GetXDistance();
	ym=P.GetYDistance();	

	if(xm>=12.0 && xm<=16.0 && ym>=15.0 && ym<=16.0)
	{
		Help.Close();
		Start.Open();
		Game();
		Start.SetMouseClickCallback(start_game);
	}
	return 1;
}


void Game()   //Display mainscreen
{
				/*CARROM*/

//C
	Start.RenderEllipse(Position(5.5+2.5,2.0), Position(5.5+4.5,4.0), Black, true);
	Start.RenderEllipse(Position(5.5+2.53,2.03), Position(5.5+4.48,3.98), White, true);
	Start.RenderRectangle(Position(5.5+3.5,2.3), Position(5.5+4.5,3.7), White, false);
//A
	Start.RenderLine(Position(5.5+5.5,2.0), Position(5.5+4.5,4.0), Black, 0.05);
	Start.RenderLine(Position(5.5+5.5,2.0), Position(5.5+5.5,4.0), Black, 0.05);
	Start.RenderLine(Position(5.5+5.0,3.0), Position(5.5+5.5,3.0), Black, 0.05);
//R
	Start.RenderEllipse(Position(5.5+6.0,2.0), Position(5.5+7.0,3.0), Black, true);
	Start.RenderEllipse(Position(5.5+6.04,2.05), Position(5.5+6.97,2.97), White, false);
	Start.RenderRectangle(Position(5.5+6.0,2.0), Position(5.5+6.5,3.0), White, false);
	Start.RenderLine(Position(5.5+6.0,2.0), Position(5.5+6.0,4.0), Black, 0.05);
	Start.RenderLine(Position(5.5+6.0,2.0), Position(5.5+6.5,2.0), Black, 0.05);
	Start.RenderLine(Position(5.5+6.0,3.0), Position(5.5+6.5,3.0), Black, 0.05);
	Start.RenderLine(Position(5.5+6.5,3.0), Position(5.5+7.0,4.0), Black, 0.05);

//R
	Start.RenderEllipse(Position(5.5+8.0-0.5,2.0), Position(5.5+9.0-0.5,3.0), Black, true);
	Start.RenderEllipse(Position(5.5+7.54,2.05), Position(5.5+8.47,2.97), White, false);
	Start.RenderRectangle(Position(5.5+8.0-0.5,2.0), Position(5.5+8.5-0.5,3.0), White, false);
	Start.RenderLine(Position(5.5+8.0-0.5,2.0), Position(5.5+8.0-0.5,4.0), Black, 0.05);
	Start.RenderLine(Position(5.5+8.0-0.5,2.0), Position(5.5+8.5-0.5,2.0), Black, 0.05);
	Start.RenderLine(Position(5.5+8.0-0.5,3.0), Position(5.5+8.5-0.5,3.0), Black, 0.05);
	Start.RenderLine(Position(5.5+8.5-0.5,3.0), Position(5.5+9.0-0.5,4.0), Black, 0.05);
//O
	Start.RenderEllipse(Position(5.5+8.8,2.0), Position(5.5+10.8,4.0), Cyan, true);
	Start.RenderEllipse(Position(5.5+9.0,2.2), Position(5.5+10.6,3.8), White, false);
	Start.RenderEllipse(Position(5.5+9.2,2.4), Position(5.5+10.4,3.6), Green, true);
//M
	Start.RenderLine(Position(5.5+11.3,2.0), Position(5.5+11.3,4.0), Black, 0.05);
	Start.RenderLine(Position(5.5+12.8,2.0), Position(5.5+12.8,4.0), Black, 0.05);
	Start.RenderLine(Position(5.5+11.3,2.0), Position(5.5+12.05,3.0), Black, 0.05);
	Start.RenderLine(Position(5.5+12.05,3.0), Position(5.5+12.8,2.0), Black, 0.05);


//Outlines
	Start.RenderRectangle(Position(7.0+2.4,2.4+3.0), Position(7.0+10.2,4.2+3.0), Red, true);//START GAME
	Start.RenderRectangle(Position(7.0+2.5,2.5+3.0), Position(7.0+10.1,4.1+3.0), White, true);

	Start.RenderRectangle(Position(7.0+2.4,5.4+3.0), Position(7.0+10.2,7.2+3.0), Red, true);//HELP
	Start.RenderRectangle(Position(7.0+2.5,5.5+3.0), Position(7.0+10.1,7.1+3.0), White, true);

	Start.RenderRectangle(Position(7.0+2.4,8.4+3.0), Position(7.0+10.2,10.2+3.0), Red, true);//EXIT
	Start.RenderRectangle(Position(7.0+2.5,8.5+3.0), Position(7.0+10.1,10.1+3.0), White, true);


				/*START GAME*/
//S
	Start.RenderLine(Position(7.0+3.0,3.0+3.0), Position(7.0+3.5,3.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+3.0,3.0+3.0), Position(7.0+3.0,3.3+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+3.0,3.3+3.0), Position(7.0+3.5,3.3+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+3.5,3.3+3.0), Position(7.0+3.5,3.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+3.0,3.6+3.0), Position(7.0+3.5,3.6+3.0), Black, 0.02);

//T
	Start.RenderLine(Position(7.0+3.7,3.0+3.0), Position(7.0+4.2,3.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+3.95,3.0+3.0), Position(7.0+3.95,3.6+3.0), Black, 0.02);

//A
	Start.RenderLine(Position(7.0+4.4,3.0+3.0), Position(7.0+4.9,3.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+4.4,3.0+3.0), Position(7.0+4.4,3.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+4.9,3.0+3.0), Position(7.0+4.9,3.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+4.4,3.3+3.0), Position(7.0+4.9,3.3+3.0), Black, 0.02);

//R
	Start.RenderLine(Position(7.0+5.1,3.0+3.0), Position(7.0+5.6,3.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+5.1,3.0+3.0), Position(7.0+5.1,3.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+5.6,3.0+3.0), Position(7.0+5.6,3.3+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+5.1,3.3+3.0), Position(7.0+5.6,3.3+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+5.3,3.3+3.0), Position(7.0+5.6,3.6+3.0), Black, 0.02);

//T
	Start.RenderLine(Position(7.0+5.8,3.0+3.0), Position(7.0+6.3,3.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+6.05,3.0+3.0), Position(7.0+6.05,3.6+3.0), Black, 0.02);

//G
	Start.RenderLine(Position(7.0+7.0,3.0+3.0), Position(7.0+7.5,3.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+7.0,3.0+3.0), Position(7.0+7.0,3.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+7.0,3.6+3.0), Position(7.0+7.5,3.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+7.5,3.6+3.0), Position(7.0+7.5,3.3+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+7.5,3.3+3.0), Position(7.0+7.25,3.3+3.0), Black, 0.02);
//A
	Start.RenderLine(Position(7.0+7.7,3.0+3.0), Position(7.0+8.2,3.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+7.7,3.0+3.0), Position(7.0+7.7,3.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+8.2,3.0+3.0), Position(7.0+8.2,3.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+7.7,3.3+3.0), Position(7.0+8.2,3.3+3.0), Black, 0.02);
//M
	Start.RenderLine(Position(7.0+8.4,3.0+3.0), Position(7.0+8.4,3.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+8.9,3.0+3.0), Position(7.0+8.9,3.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+8.4,3.0+3.0), Position(7.0+8.65,3.45+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+8.65,3.45+3.0), Position(7.0+8.9,3.0+3.0), Black, 0.02);
//E
	Start.RenderLine(Position(7.0+9.1,3.0+3.0), Position(7.0+9.1,3.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+9.1,3.0+3.0), Position(7.0+9.6,3.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+9.1,3.3+3.0), Position(7.0+9.6,3.3+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+9.1,3.6+3.0), Position(7.0+9.6,3.6+3.0), Black, 0.02);

				/*HELP*/

//H
	Start.RenderLine(Position(7.0+5.1,6.0+3.0), Position(7.0+5.1,6.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+5.6,6.0+3.0), Position(7.0+5.6,6.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+5.1,6.3+3.0), Position(7.0+5.6,6.3+3.0), Black, 0.02);
//E
	Start.RenderLine(Position(7.0+5.8,6.0+3.0), Position(7.0+5.8,6.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+5.8,6.0+3.0), Position(7.0+6.3,6.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+5.8,6.3+3.0), Position(7.0+6.3,6.3+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+5.8,6.6+3.0), Position(7.0+6.3,6.6+3.0), Black, 0.02);
//L
	Start.RenderLine(Position(7.0+6.5,6.0+3.0), Position(7.0+6.5,6.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+6.5,6.6+3.0), Position(7.0+7.0,6.6+3.0), Black, 0.02);
//P
	Start.RenderLine(Position(7.0+7.2,6.0+3.0), Position(7.0+7.7,6.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+7.2,6.0+3.0), Position(7.0+7.2,6.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+7.7,6.0+3.0), Position(7.0+7.7,6.3+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+7.2,6.3+3.0), Position(7.0+7.7,6.3+3.0), Black, 0.02);

				/*EXIT*/
//E
	Start.RenderLine(Position(7.0+5.1,9.0+3.0), Position(7.0+5.1,9.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+5.1,9.0+3.0), Position(7.0+5.6,9.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+5.1,9.3+3.0), Position(7.0+5.6,9.3+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+5.1,9.6+3.0), Position(7.0+5.6,9.6+3.0), Black, 0.02);
//X
	Start.RenderLine(Position(7.0+5.8,9.0+3.0), Position(7.0+6.3,9.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+6.3,9.0+3.0), Position(7.0+5.8,9.6+3.0), Black, 0.02);
//I
	Start.RenderLine(Position(7.0+6.5,9.0+3.0), Position(7.0+7.0,9.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+6.75,9.0+3.0), Position(7.0+6.75,9.6+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+6.5,9.6+3.0), Position(7.0+7.0,9.6+3.0), Black, 0.02);
//T
	Start.RenderLine(Position(7.0+7.2,9.0+3.0), Position(7.0+7.7,9.0+3.0), Black, 0.02);
	Start.RenderLine(Position(7.0+7.45,9.0+3.0), Position(7.0+7.45,9.6+3.0), Black, 0.02);
}


void Loading()  //Display loading bar
{
	W.RenderText(Position(12.0,5.0), Position(14.0,6.0), "Loading", Red);
	for(float a=12.0; a<=17.0; a+=0.005)
	{
		W.RenderRectangle(Position(12.0,6.0), Position(a,6.5), Black, true);
		W.RenderRectangle(Position(a,6.0), Position(17.0,6.5), White, true);
		for(long l=0; l<750000; l++);
	}
	W.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);	//White Background
} 


void Instruct()  //Display instructions
{
	Help.RenderText(Position(14.0,2.0), Position(14.0,2.0), "INSTRUCTIONS", Red);
	Help.RenderLine(Position(12.5,2.3), Position(15.5,2.3), Black, 0.02);
	Help.RenderLine(Position(12.5,2.5), Position(15.5,2.5), Black, 0.02);

	Help.RenderText(Position(0.0,4.0), Position(28.0,4.0), "How to play ?", Red);

	Help.RenderText(Position(1.0,6.0), Position(28.0,6.0), "Its a two player Carrom Game.",Black);
	Help.RenderText(Position(1.0,7.0), Position(28.0,7.0), "To place the striker, click anywhere on the board, it will be placed accordingly.",Black);
	Help.RenderText(Position(1.0,8.0), Position(28.0,8.0), "Invalid positions are automatically discarded.", Black);
	Help.RenderText(Position(1.0,9.0), Position(28.0,9.0),"To confirm the position of striker, click once on \"Set Position \".",Black);
	Help.RenderText(Position(1.0,10.0), Position(28.0,10.0),"To move the striker, click in your preferred direction.",Black);
	Help.RenderText(Position(1.0,11.0), Position(28.0,11.0),"The power will be propotional to the distance between striker's center and the mouse pointer.",Black);
	Help.RenderText(Position(1.0,12.0), Position(28.0,12.0),"You can quit anytime by clicking on the \"Quit\" button on the game window.",Black);

	Help.RenderRectangle(Position(12.0,15.0), Position(16.0,16.0),White, true);
	Help.RenderText(Position(12.0,15.0), Position(16.0,16.0), "Main Menu", Red);
}




void Carrom_Display()  //Display Carrom board with coins
{
//Holes
	W.RenderEllipse(Position(-1.5,-1.5), Position(1.5,1.5), Black, true);
	W.RenderEllipse(Position(-1.5,19.5), Position(1.5,22.5), Black, true);
	W.RenderEllipse(Position(19.5,-1.5), Position(22.5,1.5), Black, true);
	W.RenderEllipse(Position(19.5,19.5), Position(22.5,22.5), Black, true);

	W.RenderRectangle(Position(21.0,0.0), Position(28.5,21.0), White, false);
	W.RenderRectangle(Position(0.0,21.0), Position(25.0,25.0), White, false);
	W.RenderLine(Position(0.0,21.0), Position(21.0,21.0), Black, 0.04);
	W.RenderLine(Position(21.0,0.0), Position(21.0,21.0), Black, 0.04);
//White strips
	W.RenderRectangle(Position(3.0,1.5), Position(18.0,2.5), White, true);		//top
	W.RenderRectangle(Position(1.5,3.0), Position(2.5,18.0), White, true);		//Left
	W.RenderRectangle(Position(18.5,3.0), Position(19.5,18.0), White, true);	//Right
	W.RenderRectangle(Position(3.0,18.5), Position(18.0,19.5), White, true);	//Bottom
//Red Circles
	W.RenderEllipse(Position(2.5,1.5), Position(3.5,2.5), White, true);	//top left
	W.RenderEllipse(Position(2.6,1.6), Position(3.4,2.4), Red, true);	// -- 

	W.RenderEllipse(Position(17.5,1.5), Position(18.5,2.5), White, true);	//top right
	W.RenderEllipse(Position(17.6,1.6), Position(18.4,2.4), Red, true);	// --

	W.RenderEllipse(Position(1.5,2.5), Position(2.5,3.5), White, true);	//Left top
	W.RenderEllipse(Position(1.6,2.6), Position(2.4,3.4), Red, true);	// --

	W.RenderEllipse(Position(1.5,17.5), Position(2.5,18.5), White, true);	//left bottom
	W.RenderEllipse(Position(1.6,17.6), Position(2.4,18.4), Red, true);	// --

	W.RenderEllipse(Position(18.5,2.5), Position(19.5,3.5), White, true);	//right top
	W.RenderEllipse(Position(18.6,2.6), Position(19.4,3.4), Red, true);	// --

	W.RenderEllipse(Position(18.5,17.5), Position(19.5,18.5), White, true);	//right bottom
	W.RenderEllipse(Position(18.6,17.6), Position(19.4,18.4), Red, true);	// --

	W.RenderEllipse(Position(2.5,18.5), Position(3.5,19.5), White, true);	//bottom left
	W.RenderEllipse(Position(2.6,18.6), Position(3.4,19.4), Red, true);	// --

	W.RenderEllipse(Position(17.5,18.5), Position(18.5,19.5), White, true);	//bottom right
	W.RenderEllipse(Position(17.6,18.6), Position(18.4,19.4), Red, true);	// --
//CENTRE
	W.RenderEllipse(Position(7.5,7.5), Position(13.5,13.5),White, true);
	W.RenderEllipse(Position(7.6,7.6), Position(13.4,13.4),Magenta, true);		
	W.RenderEllipse(Position(7.7,7.7), Position(13.3,13.3),White, true);
	W.RenderEllipse(Position(8.5,8.5), Position(12.5,12.5),Red, false);
	W.RenderEllipse(Position(8.7,8.7), Position(12.3,12.3),Yellow, true);
//STAR
	W.RenderLine(Position(10.5,8.7), Position(8.9,11.3), Black, 0.05);
	W.RenderLine(Position(10.5,8.7), Position(12.1,11.3), Black, 0.05);
	W.RenderLine(Position(8.9,11.3), Position(12.1,11.3), Black, 0.05);
	W.RenderLine(Position(8.9,9.7), Position(12.1,9.7), Black, 0.05);
	W.RenderLine(Position(10.5,12.3), Position(8.9,9.7), Black, 0.05);
	W.RenderLine(Position(10.5,12.3), Position(12.1,9.7), Black, 0.05);
//ARROW CIRCLES
	W.RenderEllipse(Position(3.5,3.5), Position(5.5,5.5),White, true);	//Top left
	W.RenderEllipse(Position(15.5,3.5), Position(17.5,5.5),White, true);	//Top Right
	W.RenderEllipse(Position(3.5,15.5), Position(5.5,17.5),White, true);	//Bottom left
	W.RenderEllipse(Position(15.5,15.5), Position(17.5,17.5),White, true);	//Bottom right
//ARROW LINES
	W.RenderLine(Position(1.5,1.5), Position(4.5,4.5), Black, 0.05);	//Top left
	W.RenderLine(Position(19.5,1.5), Position(16.5,4.5), Black, 0.05);	//Top right
	W.RenderLine(Position(1.5,19.5), Position(4.5,16.5), Black, 0.05);	//Bottom left
	W.RenderLine(Position(19.5,19.5), Position(16.5,16.5), Black, 0.05);	//Bottom right

//ARROW HEADS
	W.RenderLine(Position(1.5,1.5), Position(2.0,1.5), Black, 0.05);	//Top left horiz.
	W.RenderLine(Position(1.5,1.5), Position(1.5,2.0), Black, 0.05);	//Top left vert.

	W.RenderLine(Position(19.5,1.5), Position(19.0,1.5), Black, 0.05);	//Top right horiz.
	W.RenderLine(Position(19.5,1.5), Position(19.5,2.0), Black, 0.05);	//Top right vert.

	W.RenderLine(Position(1.5,19.5), Position(2.0,19.5), Black, 0.05);	//Bottom left horiz.
	W.RenderLine(Position(1.5,19.5), Position(1.5,19.0), Black, 0.05);	//Bottom left vert.

	W.RenderLine(Position(19.5,19.5), Position(19.0,19.5), Black, 0.05);	//Bottom right horiz.
	W.RenderLine(Position(19.5,19.5), Position(19.5,19.0), Black, 0.05);	//Bottom right vert.

//Set Position
	W.RenderRectangle(Position(23.0,1.5), Position(27.0,3.0), Black, true);
	W.RenderRectangle(Position(23.1,1.6), Position(26.9,2.9), Black, false);
	W.RenderRectangle(Position(23.2,1.7), Position(26.8,2.8), White, true);
	W.RenderText(Position(23.0,1.5), Position(27.0,3.0),"Set Position", Red);
//Quit Game
	W.RenderRectangle(Position(23.0,16.5), Position(27.0,18.0), Black, true);
	W.RenderRectangle(Position(23.1,16.6), Position(26.9,17.9), Black, false);
	W.RenderRectangle(Position(23.2,16.7), Position(26.8,17.8), White, true);
	W.RenderText(Position(23.0,16.5), Position(27.0,18.0),"Quit Game", Red);

//Coins
	for(i=0;i<=total_gits;i++)	
	{
		if(i==0)
		{
			W.RenderEllipse(Position(x[0]-rs,y[0]-rs), Position(x[0]+rs,y[0]+rs), Cyan, true);		//Displays pos of striker
			W.RenderEllipse(Position(x[0]-rs+0.2,y[0]-rs+0.2), Position(x[0]+rs-0.2,y[0]+rs-0.2),White, false);
			W.RenderEllipse(Position(x[0]-rs+0.4,y[0]-rs+0.4), Position(x[0]+rs-0.4,y[0]+rs-0.4),Green, true);
		}
		else if(i==1)
			W.RenderEllipse( Position(x[i]-rg,y[i]-rg),Position(x[i]+rg,y[i]+rg), Red, true);
		else if(i>1 && i<11)
			W.RenderEllipse( Position(x[i]-rg,y[i]-rg),Position(x[i]+rg,y[i]+rg), Magenta, true);
		else
			W.RenderEllipse( Position(x[i]-rg,y[i]-rg),Position(x[i]+rg,y[i]+rg), Black, true);
		
	}
}


int Input(const Position &P)
{
	xm=P.GetXDistance();
	ym=P.GetYDistance();

	if(xm>23.0 && xm<27.0 && ym>16.5 && ym<18.0)	// If there is a click inside quit game box
	{
		W.Message("Thanks for Playing");
		W.Close();
	}	

	if((k==0 || k==2) && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//k=0 means striker position has not been locked yet
	{
		if(xm>4.25 && xm<16.75 && ym>1.75 +len && ym<2.25 + len)	// x & y both inside the strip
		{
			x[0]=P.GetXDistance();	y[0]=P.GetYDistance();	
		}
	
		else if(xm<=04.25)	//x left of the strip
		{
			x[0]=3.0;	y[0]=2.0+len;	
		}

		else if(xm>=16.75 && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x right of the strip
		{
			x[0]=18.0;	y[0]=2.0+len;	
		}

		else if(xm>04.25 && xm<16.75 && ym<=1.75 + len && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x inside & y up the strip
		{
			x[0]=P.GetXDistance();	y[0]=1.75+len;
		}

		else if(xm>04.25 && xm<16.75 && ym>=2.25+len && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x inside & y down the strip
		{
			x[0]=P.GetXDistance();	y[0]=2.25+len;
		}
		k=2;
		chkoverlap();
		W.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);	//White Background		
		Carrom_Display();

		return 1;
	}

	if(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0 && validpos!=0 && k==2)	//Clicked on the Set Position button
	{
		k=1;
		chkoverlap();
		W.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);	//White Background		
		Carrom_Display();
		return 1;
	}		
	
	if(k==1) //k=1 means striker position has already been set and the next click would determine striker velocity and direction
	{
		if((cp==0 && ym>y[0])||(cp==1 && ym<y[0]))	//user cannot hit backward
		{
		dist=sqrt(pow((xm-x[0]),2)+pow((ym-y[0]),2));
		vel=powfact*2*dist;	//vel is proportional to distance
		b=atan((ym-y[0])/(xm-x[0]));

		//because atan gives valus between -pi/2 to +pi/2
		if(b<0 && cp==0)
			b=b+pi;
		if(b>0 && cp==1)
			b=b-pi;
		//computing components
		vx[0]=vel*cos(b);
		vy[0]=vel*sin(b);

		chkdirection();
		
		if(valid)
		{
			//reset velocities because they might have been modified in chkdirection()
			for(i=1;i<=total_gits;i++)
			{
				vx[i]=vy[i]=0;
			}
			vx[0]=vel*cos(b);
			vy[0]=vel*sin(b);
		
			int flag=1; //1:something is moving  0:nothing is moving
		
			while(flag==1)
			{
				flag=0;

				Move();
				Collision();
				Carrom_Display();
				for(long int z=0;z<1700000;z++);	//time lag
		
				for(int i=0;i<=total_gits;i++)   //check for flag value
				{
					if((abs(vx[i])>0.0001)||abs(vy[i])>0.0001)
					{
						flag=1;
						break;
					}
				}
			}

			checkstop();
			Carrom_Display();
			k=0;
		}
		}
	}
	
	if(k==3)
	{
		Set(tobeSet);	
		k=0;
	}
	
	return 1;
}

void chkoverlap()	//checks whether the inputted position of striker overlaps with any other coin
{
	valid=1;
	for(i=1;i<=total_gits;i++)
	{		
		if(double(pow(double(pow((x[i]-x[0]),2))+(double(pow((y[i]-y[0]),2))),0.5))<rg+rs)
		valid=0;
	}
	
	if(valid==0)
		if(validpos)
		{
			x[0]=cvspx;	//if current input is invalid and if there exists a old valid position(validpos!=0), then set striker at old valid position
			y[0]=cvspy;
		}
		else
		{
			x[0]=-10;    // if no old valid position available make it disappear
			y[0]=-10;
		}
	
	if(valid==1)
		{
			cvspx=x[0];   // if current input is valid set cvspx and cvspy, no. of valid positions available(validpos) increases
			cvspy=y[0];
			validpos++;
		}
}

void chkdirection()	//checks whether direction input is valid or not
{
	disp=0;		//don't show to the user what is being analyzed
	valid=1;
	while(collisions==0)	//call move and collisions alternately till atleast one collision occurs
	{
		Move();
		Collision();
	}
	if(abs(ccy-(1.5+len))<rg || abs(ccy-(2.5+len))<rg) //if the currently colliding coin does cross the hitting strip, input is invalid
		valid=0;
	
	if(valid==0)
	{
		x[0]=cvspx;	//for invalid input set striker position back
		y[0]=cvspy;
	}
	if(valid==1)
	{
		cvspx=x[0];    //even for valid positions we should set it back.....what is happening here? It will be sorted out once I have access to EzWindows...
		cvspy=y[0];
	}
			
	disp=1;	//after analyzing validity unlock the display
}

void Move()
{
	i=0;
	r=rs;
	for(i=0;i<=total_gits;i++)
	{
		if(	( (x[i]*x[i]+y[i]*y[i])<2.25 ) ||				//checks whether a coin os pocketed
			( ((x[i]-21)*(x[i]-21)+y[i]*y[i])<2.25 ) ||
			( (x[i]*x[i]+(y[i]-21)*(y[i]-21))<2.25 ) ||
			( ((x[i]-21)*(x[i]-21)+(y[i]-21)*(y[i]-21))<2.25 ) 
		  )
        	{
            		x[i]=-5.0;	//make the pocketed coin invisible
            		y[i]=-5.0;
			vx[i]=0.0;	//set it's velocity to zero
            		vy[i]=0.0;
            		if(i!=1)
            			possess[cp][i]=1;	//if it's not the queen, give possession directly
            		this_turn[i]=1;
            		if(i==0)
            			due=1;		//if it's striker set due to 1
            	}
            	
		W.RenderEllipse( Position(x[i]-r,y[i]-r),Position(x[i]+r,y[i]+r), White, false);	//erase coin at old position
		x[i]+=vx[i];	//modify x using vx
		if(x[i]<r && possess[0][i]==0 && possess[1][i]==0)			//if a coin crosses wall in between two frames, set to to touch the wall
			x[i]=r;
		if(x[i]>21-r && possess[0][i]==0 && possess[1][i]==0)
			x[i]=21-r;

		y[i]+=vy[i];   //modify y using vy
		if(y[i]<r && possess[0][i]==0 && possess[1][i]==0)			//if a coin crosses wall in between two frames, set to to touch the wall
			y[i]=r;
		if(y[i]>21-r && possess[0][i]==0 && possess[1][i]==0)
			y[i]=21-r;

		//render all the coins again. Here we are not calling the Carrom_Display() because that causes flickering problem. So, we have to rewrite this here.
		if(r==rs)
		{
			W.RenderEllipse( Position(x[i]-r,y[i]-r),Position(x[i]+r,y[i]+r), Cyan, true);
			W.RenderEllipse(Position(x[0]-rs+0.2,y[0]-rs+0.2), Position(x[0]+rs-0.2,y[0]+rs-0.2),White, false);
			W.RenderEllipse(Position(x[0]-rs+0.4,y[0]-rs+0.4), Position(x[0]+rs-0.4,y[0]+rs-0.4),Green, true);
		}
		else if(i==1)
			W.RenderEllipse(Position(x[i]-r,y[i]-r),Position(x[i]+r,y[i]+r), Red, true);
		else
			W.RenderEllipse(Position(x[i]-r,y[i]-r),Position(x[i]+r,y[i]+r), Magenta, true);

		//if any coin has got zero velocity, do not modify velocities
		if(vx[i]==0 && vy[i]==0)
		{
			r=rg;
			continue;
		}

		//Modifications in velocities using accelration
		if((vx[i]*(vx[i]-ACCL*vx[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)))))<=0)
											//the big thing you see is nothing but vx/sqrt(vx^2+vy^2)=cos(theta)
				//here we check if vx changes it's direction and if it does, it must have passes through zero, where it should have stopped. Hence set vx=0
		vx[i]=0;
		else
		vx[i]-=ACCL*vx[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)));	//else modify vx, similarly for vy

		if((vy[i]*(vy[i]-ACCL*vy[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)))))<=0)
		vy[i]=0;
		else
		vy[i]-=ACCL*vy[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)));
		r=rg;	//set r=rg because after one iteration(for the striker), radius is different...
	}
}



int Collision()
{
	int i=0,j;
	float T,Pn,vi_n,vj_n,vi_t,vj_t;
	float d=rg+rs,M=MS,m=MG,cx,cy;
	float D;
	r=rs;
	
	for(i=0;i<=total_gits;i++)
	{
		for(j=i+1;j<=total_gits;j++)
		{
			D=double(pow(double(pow((x[i]-x[j]),2))+(double(pow((y[i]-y[j]),2))),0.5));   //D=Distance between centres
			if(D<d)    //checks for a collision
				{
					T=atan((y[i]-y[j])/(x[i]-x[j]));
					cx=(x[i]*rg+x[j]*r)/(rg+r);	//coordinates of touching point of the two colliding coins
					cy=(y[i]*rg+y[j]*r)/(rg+r);

					//if they collide in between two frames, they will overlap. Separate out the coins so that they just touch
					//all if conditions are to avoid zero/zero
					if(x[i]!=cx)
						x[i]=cx+r*abs(cos(T))*(x[i]-cx)/abs(x[i]-cx);
					if(y[i]!=cy)
						y[i]=cy+r*abs(sin(T))*(y[i]-cy)/abs(y[i]-cy);
					if(x[j]!=cx)
						x[j]=cx+rg*abs(cos(T))*(x[j]-cx)/abs(x[j]-cx);
					if(y[j]!=cy)
						y[j]=cy+rg*abs(sin(T))*(y[j]-cy)/abs(y[j]-cy);

					//Calculate new velocities using momentum conservation, predefined masses, and predifined coefficient of restitution

					vi_n=vx[i]*cos(T)+vy[i]*sin(T);	//velocity of ith coin along the normal at the colliding point
					vi_t=vy[i]*cos(T)-vx[i]*sin(T); //velocity of ith coin along the tangent at the colliding point
					vj_n=vx[j]*cos(T)+vy[j]*sin(T);
					vj_t=vy[j]*cos(T)-vx[j]*sin(T);
					Pn= m*vj_n + M*vi_n;		//Total momentum along the normal

					vi_n=(Pn-m*E*(vi_n-vj_n))/(M+m);
					vj_n=(Pn-M*E*(vj_n-vi_n))/(M+m);

					vx[j]=vj_n*cos(T)-vj_t*sin(T);
					vy[j]=vj_t*cos(T)+vj_n*sin(T);
					vx[i]=vi_n*cos(T)-vi_t*sin(T);
					vy[i]=vi_t*cos(T)+vi_n*sin(T);
					
					collisions++;	//update no. of collisions
					//update current colliding coin's location
					/*Here we use j because j always contains git coordinates, and we use ccx and ccy in chkdirection
						where we are only innterested in coin location*/
					ccx=x[j];
					ccy=y[j];
					
				}			
		}
		
		if (y[i]-r==0 || (y[i]+r)==21)	//Coin wall collision
		{
			vy[i]=-E*vy[i];
			collisions++;
		}
		if (x[i]-r==0 || (x[i]+r)==21)
		{
			vx[i]=-E*vx[i];
			collisions++;
		}
		d=2*rg;	//after one loop has run, coins collide when their centres are 2*rg apart
		r=rg;	//radius of ith coin is rg
		M=MG;	//Mass of the ith coin is MG
	}
return collisions;	
}



void checkstop()	//runs after every turn
{   
    if(due==1)	//if striker was pocketed
    {
    	W.Message("Your Punishment is due ");

        for(i=total_gits;i>1;i--)	//Set back all the coins that have been pocketed in this chance
        {
            if(possess[cp][i]==1 && this_turn[i]==1)
            {
            	k=3;
            	tobeSet=i;
            	possess[cp][i]=0;
            }
        }
        
        for(i=total_gits;i>1;i--)	//Set one more coin as a due
        {
            if(possess[cp][i]==1)
            {
            	k=3;
            	tobeSet=i;
            	possess[cp][i]=0;
            	break;
            }
        }   

        due=0;
    }

    if(queen==1)	//if queen was pocketed last time
    {
    	for(i=total_gits;i>1;i--)
    		if(this_turn[i]==1)		//if any coin was pocketed in this turn
    		{
    			possess[cp][1]=1;	//Give possession to current user
    			queen=0;
    			break;
    		}
    	
    	if(i==1)	//if previous loop wasn't broken
    	{
    		Set(1);  //set the queen back
    		queen=0;
    	}
    }


    if(this_turn[1]==1)		//if queen was pocketed
        queen=1;

    for(i=1;i<=total_gits;i++)	//check whether anything was pocketed in the current turn
    {
    	if(this_turn[i]==1)
    		break;
    }
    
    if(i==total_gits+1)		//if nothing was pocketed change current player
    {
    	cp=(cp+1)%2;
    }
    if(cp==0)
    {	W.Message("Player 1's Turn");
	len=0;
    }
    if(cp==1)
    {	W.Message("Player 2's Turn");
	len=17.0;
    }
   
    for(i=0;i<=total_gits;i++)		//set all this_turn to zero
    this_turn[i]=0;

    k=0;
for(i=0;i<=total_gits;i++)		//set all possessions to zero
{
	cout<<"\t"<<possess[0][i];
	cout<<"\t"<<possess[1][i];
}

}


void Set(int k) //The SetCoin function
{
	int valid=1;
	
	int d=sqrt(pow((xm-10.5),2)+pow((ym-10.5),2));
	
	for(i=1;i<=total_gits;i++)	//Check for overlap
	{
		if(i!=k && sqrt(pow((xm-x[i]),2)+pow((ym-y[i]),2)<2*rg))
			valid=0;
	}	


	if(d<3.0 && valid==1)
	{
		x[i]=xm;
		y[i]=ym;
		Carrom_Display();
	}
		
	else 
		W.Message("Do it Again");
}

