#include "ezwin.h"
#include <cassert>
#include <cmath>
#define pi 3.14159265
SimpleWindow W("Carrom", 28.0, 21.0,Position(0.0, 0.0));
float x,y,z,a,b;
int Input(const Position &P)
{
	x=P.GetXDistance();
	y=P.GetYDistance();
	return 1;
}

void Board()
{
	W.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);	//White Background
//Holes
	W.RenderEllipse(Position(-1.5,-1.5), Position(1.5,1.5), Black, true);
	W.RenderEllipse(Position(-1.5,19.5), Position(1.5,22.5), Black, true);
	W.RenderEllipse(Position(19.5,-1.5), Position(22.5,1.5), Black, true);
	W.RenderEllipse(Position(19.5,19.5), Position(22.5,22.5), Black, true);

	W.RenderRectangle(Position(21.0,0.0), Position(28.5,21.0), White, false);
	W.RenderRectangle(Position(0.0,21.0), Position(25.0,25.0), White, false);
	W.RenderLine(Position(0.0,21.0), Position(21.0,21.0), Black, 0.04);
	W.RenderLine(Position(21.0,0.0), Position(21.0,21.0), Black, 0.04);
//White strips
	W.RenderRectangle(Position(3.0,1.5), Position(18.0,2.5), White, true);	//top
	W.RenderRectangle(Position(1.5,3.0), Position(2.5,18.0), White, true);	//Left
	W.RenderRectangle(Position(18.5,3.0), Position(19.5,18.0), White, true);	//Right
	W.RenderRectangle(Position(3.0,18.5), Position(18.0,19.5), White, true);	//Bottom
//Red Circles
	W.RenderEllipse(Position(2.5,1.5), Position(3.5,2.5), White, true);	//top left
	W.RenderEllipse(Position(2.6,1.6), Position(3.4,2.4), Red, true);	// -- 

	W.RenderEllipse(Position(17.5,1.5), Position(18.5,2.5), White, true);	//top right
	W.RenderEllipse(Position(17.6,1.6), Position(18.4,2.4), Red, true);	// --

	W.RenderEllipse(Position(1.5,2.5), Position(2.5,3.5), White, true);	//Left top
	W.RenderEllipse(Position(1.6,2.6), Position(2.4,3.4), Red, true);	// --

	W.RenderEllipse(Position(1.5,17.5), Position(2.5,18.5), White, true);	//left bottom
	W.RenderEllipse(Position(1.6,17.6), Position(2.4,18.4), Red, true);	// --

	W.RenderEllipse(Position(18.5,2.5), Position(19.5,3.5), White, true);	//right top
	W.RenderEllipse(Position(18.6,2.6), Position(19.4,3.4), Red, true);	// --

	W.RenderEllipse(Position(18.5,17.5), Position(19.5,18.5), White, true);	//right bottom
	W.RenderEllipse(Position(18.6,17.6), Position(19.4,18.4), Red, true);	// --

	W.RenderEllipse(Position(2.5,18.5), Position(3.5,19.5), White, true);	//bottom left
	W.RenderEllipse(Position(2.6,18.6), Position(3.4,19.4), Red, true);	// --

	W.RenderEllipse(Position(17.5,18.5), Position(18.5,19.5), White, true);	//bottom right
	W.RenderEllipse(Position(17.6,18.6), Position(18.4,19.4), Red, true);	// --
//CENTRE
	W.RenderEllipse(Position(7.5,7.5), Position(13.5,13.5),White, true);
	W.RenderEllipse(Position(7.6,7.6), Position(13.4,13.4),Magenta, true);		
	W.RenderEllipse(Position(7.7,7.7), Position(13.3,13.3),White, true);
	W.RenderEllipse(Position(8.5,8.5), Position(12.5,12.5),Red, false);
	W.RenderEllipse(Position(8.7,8.7), Position(12.3,12.3),Yellow, true);
//STAR
	W.RenderLine(Position(10.5,8.7), Position(8.9,11.3), Blue, 0.05);
	W.RenderLine(Position(10.5,8.7), Position(12.1,11.3), Blue, 0.05);
	W.RenderLine(Position(8.9,11.3), Position(12.1,11.3), Blue, 0.05);
	W.RenderLine(Position(8.9,9.7), Position(12.1,9.7), Blue, 0.05);
	W.RenderLine(Position(10.5,12.3), Position(8.9,9.7), Blue, 0.05);
	W.RenderLine(Position(10.5,12.3), Position(12.1,9.7), Blue, 0.05);

	W.RenderEllipse(Position(3.5,3.5), Position(5.5,5.5),White, true);
	W.RenderEllipse(Position(15.5,3.5), Position(17.5,5.5),White, true);
	W.RenderEllipse(Position(3.5,15.5), Position(5.5,17.5),White, true);
	W.RenderEllipse(Position(15.5,15.5), Position(17.5,17.5),White, true);

	W.RenderLine(Position(1.5,1.5), Position(4.5,4.5), Black, 0.05);
	W.RenderLine(Position(19.5,1.5), Position(16.5,4.5), Black, 0.05);
	W.RenderLine(Position(1.5,19.5), Position(4.5,16.5), Black, 0.05);
	W.RenderLine(Position(19.5,19.5), Position(16.5,16.5), Black, 0.05);
}

int ApiMain() 
{
	W.Open();
	assert(W.GetStatus() == WindowOpen);
	Board();

	/*W.RenderEllipse(Position(9.75,1.25), Position(11.25,2.75),Cyan, true);
	W.RenderEllipse(Position(9.95,1.45), Position(11.05,2.55),White, false);
	W.RenderEllipse(Position(10.15,1.65), Position(10.85,2.35),Green, true);

	cout<<"Enter angle in degrees : ";	cin>>a;		

	z=0.35;
	if((int)a!=90)
	{
		b = a*pi/180;
		for(x=10.5 ; z>=0 ; x+=z*cos(b),z-=0.005)
		{	
			Board();
			y = tan(b) * (x-10.5) + 2.0;
			W.RenderEllipse(Position(x-0.75,y-0.75), Position(x+0.75,y+0.75), Cyan, true);
			W.RenderEllipse(Position(x-0.55,y-0.55), Position(x+0.55,y+0.55), White, false);
			W.RenderEllipse(Position(x-0.35,y-0.35), Position(x+0.35,y+0.35), Green, true);
			for(int j=0;j<10000000;j++);
		}
	}

	else
	{
		for(y=2.0 ; z>=0 ; y+=z*cos(b),z-=0.005)
		{
			Board();
			W.RenderEllipse(Position(9.75,y-0.75), Position(11.25,y+0.75), Cyan, true);
			W.RenderEllipse(Position(9.95,y-0.55), Position(11.05,y+0.55), White, false);
			W.RenderEllipse(Position(10.15,y-0.35), Position(10.85,y+0.35), Green, true);
			for(int j=0;j<12000000;j++);
		}
		
	}*/

	return 0;
}

