#define ACCL 0.00001
#define rs 0.5 //Change radius of striker after modifications
#define rg 0.5
#define MS 1
#define MG 1
#define E 0.85
#include "ezwin.h"
#include <cassert>
#include <cmath>
using namespace std;

SimpleWindow TP("Carrom", 25.5, 20, Position(0.5, 0.5));

int i;
float r=rs;
float x[20],y[20],vx[20],vy[20];

void Move();
void Collision();

int ApiMain()
{
	
	for(i=0;i<20;i++)
	{
		x[i]=i;
		y[i]=i;
		vx[i]=0;
		vy[i]=0;
	}
	vx[0]=0.03;
	vy[0]=0.03;

	int flag=1;
	TP.Open();
	TP.RenderLine(Position(20,0),Position(20,20),Red,0.0);
	TP.RenderRectangle(Position(20.5,1), Position(25,1.75),White, true);
	
	i=0;
	do
	{	
		TP.RenderEllipse( Position(x[i],y[i]),Position(x[i]+2*r,y[i]+2*r), Blue, true);		
		i++;
		r=rg;
	}
	while(i<20);	

	while(flag==1)
	{
		flag=0;
		Move();
		Collision();
	//cout<<vx[0]<<"\t"<<vy[0]<<"\n"<<vx[1]<<"\t"<<vy[1];
		for(long int z=0;z<5000000;z++);

		for(int i=0;i<20;i++)
		{
			if((vx[i]>0.001)||(vy[i])>0.001)
			{
				flag=1;
				break;
			}
		}
	}

return 0;
}


void Move()
{
	i=0;
	r=rs;
	for(i=0;i<20;i++)
	{
		TP.RenderEllipse( Position(x[i],y[i]),Position(x[i]+2*r,y[i]+2*r), White, false);
		x[i]+=vx[i];
		y[i]+=vy[i];
		TP.RenderEllipse( Position(x[i],y[i]),Position(x[i]+2*r,y[i]+2*r), Blue, false);
		
		if(vx[i]==0 && vy[i]==0)
			continue;

		if(    (          vx[i]*(vx[i]-ACCL*vx[i]/  (pow((pow(vx[i],2))+(pow(vy[i],2)),0.5))  ))<=0    )
		vx[i]=0;
		else
		vx[i]-=ACCL*vx[i]/ (pow((pow(vx[i],2))+(pow(vy[i],2)),0.5));

		if(    (          vy[i]*(vy[i]-ACCL*vy[i]/  (pow((pow(vx[i],2))+(pow(vy[i],2)),0.5))  ))<=0    )
		vy[i]=0;
		else
		vy[i]-=ACCL*vy[i]/ (pow((pow(vx[i],2))+(pow(vy[i],2)),0.5));
		r=rg;
	}
}



void Collision()
{
	int i=0,j;
	float T,Pn,vi_n,vj_n,vi_t,vj_t;
	float d=rg+rs, M=MS, m=MG;

	do
	{
		for(j=i+1;j<20;j++)
		{
			if( (pow ((pow((x[i]-x[j]),2))+((pow((y[i]-y[j]),2))),0.5))<d)
				{
					T=atan((y[i]-y[j])/(x[i]-x[j]));
					vi_n=vx[i]*cos(T)+vy[i]*sin(T);
					vi_t=vy[i]*cos(T)-vx[i]*sin(T);
					vj_n=vx[j]*cos(T)+vy[j]*sin(T);
					vj_t=vy[j]*cos(T)-vx[j]*sin(T);
					Pn= m*vj_n + M*vi_n;

cout/*<<vi_n<<"\t"<<vi_t<<"\t"<<vj_n<<"\t"<<vj_t<<"\n"*/<<Pn<<"\n";

					vi_n=(Pn-m*E*(vi_n-vj_n))/(M+m);
					vj_n=(Pn-M*E*(vj_n-vi_n))/(M+m);

					vx[j]=vj_n*cos(T)-vj_t*sin(T);
					vy[j]=vj_t*cos(T)+vj_n*sin(T);
					vx[i]=vi_n*cos(T)-vi_t*sin(T);
					vy[i]=vi_t*cos(T)+vi_n*sin(T);		
				}			
		}
		i++;
		d=2*rg;
		M=MG;
	}
	while(i<20);
}











