#define ACCL 0.00001
#define rs 0.75
#define rg 0.5
#define MS 1
#define MG 1
#define E 0.85
#include "ezwin.h"
#include <cassert>
#include <cmath>
using namespace std;

SimpleWindow TP("Carrom", 25.5, 20, Position(0.5, 0.5));

int i,cp=1,due=0,queen=0;
float r;
float x[20],y[20],vx[20],vy[20];

int possess[2][20],this_turn[20];
for(i=0;i<20;i++)
{
	possess[0][i]=possess[1][i]=0;
}

void Move();
int Collision();

int ApiMain()
{
	
	for(i=0;i<20;i++)
	{
		x[i]=2*i+2;
		y[i]=2*i+2;
		vx[i]=0;
		vy[i]=0;
	}
	vx[0]=0.015;
	vy[0]=0.020;

	int flag=1;
	TP.Open();
	TP.RenderLine(Position(20,0),Position(20,20),Red,0.0);
	TP.RenderRectangle(Position(20.5,1), Position(25,1.75),White, true);
	
	i=0;
	r=rs;	
	for(i=0;i<20;i++)
	{	
		TP.RenderEllipse(Position(x[i]-r,y[i]-r),Position(x[i]+r,y[i]+r), Blue, true);		
		r=rg;
	}

	while(flag==1)
	{
		flag=0;
		Move();
		Collision();
		for(long int z=0;z<700000;z++);

		for(int i=0;i<20;i++)
		{
			if((abs(vx[i])>0.0001)||abs(vy[i])>0.0001)
			{
				flag=1;
				break;
			}
		}
	}
	
return 0;
}


void Move()
{
	i=0;
	r=rs;
	for(i=0;i<20;i++)
	{
		if(((x[i]*x[i])+(y[i]*y[i])<2.25)||((x[i]*x[i])+((y[i]-21)*(y[i]-21))<2.25)||(((x[i]-21)*(x[i]-21))+(y[i]*y[i])<2.25)||(((x[i]-21)*(x[i]-21))+((y[i]-21)*(y[i]-21))<2.25))
        	{
            		x[i]=-5.0;
            		y[i]=-5.0;
            		vx[i]=0.0;
            		vy[i]=0.0;
            		if(i!=1)
            			possess[cp][i]=1;
            		this_turn[i]=1;
            		if(i==0)
            			due=1;
            	}
            	
		TP.RenderEllipse( Position(x[i]-r,y[i]-r),Position(x[i]+r,y[i]+r), White, false);
		x[i]+=vx[i];
		if(x[i]<0)
			x[i]=0;
		if(x[i]>21-r)
			x[i]=21-r;

		y[i]+=vy[i];
		if(y[i]<0)
			y[i]=0;
		if(y[i]>21-r)
			y[i]=21-r;

		TP.RenderEllipse( Position(x[i]-r,y[i]-r),Position(x[i]+r,y[i]+r), Blue, false);
		
		if(vx[i]==0 && vy[i]==0)
		{
			r=rg;
			continue;
		}

		if((vx[i]*(vx[i]-ACCL*vx[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)))))<=0)
		vx[i]=0;
		else
		vx[i]-=ACCL*vx[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)));

		if((vy[i]*(vy[i]-ACCL*vy[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)))))<=0)
		vy[i]=0;
		else
		vy[i]-=ACCL*vy[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)));
		r=rg;
		
	}
}



int Collision()
{
	int i=0,j;
	float T,Pn,vi_n,vj_n,vi_t,vj_t;
	float d=rg+rs,M=MS,m=MG,cx,cy;
	float D;
	r=rs;
	
	for(i=0;i<20;i++)
	{
		for(j=i+1;j<20;j++)
		{
			D=double(pow(double(pow((x[i]-x[j]),2))+(double(pow((y[i]-y[j]),2))),0.5));
			if(D<d)
				{
					T=atan((y[i]-y[j])/(x[i]-x[j]));
					cx=(x[i]*rg+x[j]*r)/(rg+r);
					cy=(y[i]*rg+y[j]*r)/(rg+r);

			
					
					x[i]=cx+r*abs(cos(T))*(x[i]-cx)/abs(x[i]-cx);
					y[i]=cy+r*abs(sin(T))*(y[i]-cy)/abs(y[i]-cy);
					x[j]=cx+rg*abs(cos(T))*(x[j]-cx)/abs(x[j]-cx);
					y[j]=cy+rg*abs(sin(T))*(y[j]-cy)/abs(y[j]-cy);
					
					Carrom_Display();
					
					vi_n=vx[i]*cos(T)+vy[i]*sin(T);
					vi_t=vy[i]*cos(T)-vx[i]*sin(T);
					vj_n=vx[j]*cos(T)+vy[j]*sin(T);
					vj_t=vy[j]*cos(T)-vx[j]*sin(T);
					Pn= m*vj_n + M*vi_n;

					vi_n=(Pn-m*E*(vi_n-vj_n))/(M+m);
					vj_n=(Pn-M*E*(vj_n-vi_n))/(M+m);

					vx[j]=vj_n*cos(T)-vj_t*sin(T);
					vy[j]=vj_t*cos(T)+vj_n*sin(T);
					vx[i]=vi_n*cos(T)-vi_t*sin(T);
					vy[i]=vi_t*cos(T)+vi_n*sin(T);
					
					collisions++;
					ccx=x[j];
					ccy=y[j];
					
				}			
		}
		
		if (y[i]-r==0 || (y[i]+r)==21)
		{
			vy[i]=-E*vy[i];
			collisions++;
		}
		if (x[i]-r==0 || (x[i]+r)==21)
		{
			vx[i]=-E*vx[i];
			collisions++;
		}
		d=2*rg;
		r=rg;
		M=MG;
	}
return collisions;	
}





void checkstop()
{
    if(due==1)
    {
        for(i=20;i>1;i--)
        {
            if(possess[cp][i]==1 && this_turn[i]==1)
            Set(i);
            possess[cp][i]=0;
        }
        
        for(i=20;i>1;i--)
        {
            if(possess[cp][i]==1)
            Set(i);
            break;
        }   
     	if(i==1)
    	{
            //points deduction or whatever to be done, pls insert here.
        }
        due=0;
    }

    if(queen==1)
    {
    	for(i=20;i>1;i--)
    		if(this_turn[i]==1)
    		{
    			possess[cp][1]=1;
    			queen=0;
    			break;
    		}
    	
    	if(i==1)
    	{
    		Set(1);
    		queen=0;
    	}
    }


    if(this_turn[1]=1)
        queen=1;

    for(i=0;i<20;i++)
    this_turn[i]=0;
}
