#define ACCL 0.0006
#define rs 0.75 //Change radius of striker after modifications
#define rg 0.5
#define MS 1
#define MG 1
#define total_gits 6
#define powfact 0.02
#define pi 3.14159265
#define E 0.85


#include "ezwin.h"
#include <cassert>
#include <cmath>
#include <iostream>
#include <cstring>
#include "Alert.h"

using namespace std;

SimpleWindow Start("Game",28.0,21.0, Position(0.5,0.5));
SimpleWindow W("CARROM", 28.0, 21, Position(0.5, 0.5));
SimpleWindow Help("Instrcutions", 28.0, 21, Position(0.5, 0.5));

int i,k=0,disp=1,valid,collisions=0;
float r;
float x[total_gits+1],y[total_gits+1],vx[total_gits+1],vy[total_gits+1];
float xm,ym,dist,b,vel;
float ccx=-10,ccy=-10;

void Carrom_Display();
void Move();
int Collision();
void Instruct();
void Loading();

int chkvalid();
int start_game(const Position &);
int Input(const Position &);
int help_game(const Position &);

int ApiMain()
{
	Start.Open();
	Start.RenderText(Position(12.0,2.0), Position(16.0,3.0), "START GAME", Red);
	Start.RenderText(Position(12.0,5.0), Position(16.0,6.0), "HELP", Red);
	Start.RenderText(Position(12.0,8.0), Position(16.0,9.0), "EXIT", Red);

//Mouse Clicks

	Start.SetMouseClickCallback(start_game);
/*	W.SetMouseClickCallback(Input);
	Help.SetMouseClickCallback(help_game);
*/
	return 0;
}


int start_game(const Position &P)
{
	xm=P.GetXDistance();
	ym=P.GetYDistance();

	if(xm>=12.0 && xm<=16.0 && ym>=2.0 && ym<=3.0)
	{
		Start.Close();
		W.Open();
		Loading();
		x[0]=10.5;	y[0]=2.0;

		for(i=2;(i/2)<=total_gits;i+=2)
		{
			x[i/2]=i+2;
			y[i/2]=6.0;
			vx[i/2]=0;
			vy[i/2]=0;
		}

		Carrom_Display();
		W.Message("Player 1's turn");
		W.SetMouseClickCallback(Input);
	}

	else if(xm>=12.0 && xm<=16.0 && ym>=5.0 && ym<=6.0)
	{
		Help.Open();
		Instruct();
		Help.SetMouseClickCallback(help_game);
	}

	else if(xm>=12.0 && xm<=16.0 && ym>=8.0 && ym<=9.0)
		Start.Close();

	return 1;
}


int help_game(const Position &P)
{
	xm=P.GetXDistance();
	ym=P.GetYDistance();	

	if(xm>=12.0 && xm<=16.0 && ym>=15.0 && ym<=16.0)
		Help.Close();

	return 1;
}


void Loading()
{
	W.RenderText(Position(12.0,5.0), Position(14.0,6.0), "Loading", Red);
	for(float a=12.0; a<=17.0; a+=0.005)
	{
		W.RenderRectangle(Position(12.0,6.0), Position(a,6.5), Blue, true);
		W.RenderRectangle(Position(a,6.0), Position(17.0,6.5), White, true);
		for(long l=0; l<750000; l++);
	}
} 


void Instruct()
{
	Help.RenderText(Position(12.0,2.0), Position(16.0,2.0), "INSTRUCTIONS", Red);
	Help.RenderText(Position(12.0,15.0), Position(16.0,16.0), "Main Menu", Red);
}



void Carrom_Display()
{
	if(disp==1)
	{
		W.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);	//White Background
	//	W.RenderRectangle(Position(3.0,1.5), Position(18.0,2.5), White, true);	//top
		W.RenderLine(Position(21,0),Position(21,21),Red,0.0);
	//Set Position	
		W.RenderRectangle(Position(23.0,1.5), Position(27.0,3.0), Black, true);
		W.RenderRectangle(Position(23.1,1.6), Position(26.9,2.9), Black, false);
		W.RenderRectangle(Position(23.2,1.7), Position(26.8,2.8), White, true);
		W.RenderText(Position(23.0,1.5), Position(27.0,3.0),"Set Position", Red);
		
		W.RenderRectangle(Position(23.0,16.5), Position(27.0,18.0), Black, true);
		W.RenderRectangle(Position(23.1,16.6), Position(26.9,17.9), Black, false);
		W.RenderRectangle(Position(23.2,16.7), Position(26.8,17.8), White, true);
		W.RenderText(Position(23.0,16.5), Position(27.0,18.0),"Quit Game", Red);
	
		for(i=0;i<=total_gits;i++)
		{
			if(i==0)
			{
				W.RenderEllipse(Position(x[0]-rs,y[0]-rs), Position(x[0]+rs,y[0]+rs), Blue, true);
	//			W.RenderEllipse(Position(x[0]-rs+0.2,y[0]-rs+0.2), Position(x[0]+rs-0.2,y[0]+rs-0.2),White, false);
	//			W.RenderEllipse(Position(x[0]-rs+0.4,y[0]-rs+0.4), Position(x[0]+rs-0.4,y[0]+rs-0.4),Green, true);
			}
			else
				W.RenderEllipse( Position(x[i]-rg,y[i]-rg),Position(x[i]+rg,y[i]+rg), Blue, true);
		}
	}
}

/*
void Carrom_Display()
{
	if(disp==1)
	{
		W.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);	//White Background
	//Holes
		W.RenderEllipse(Position(-1.5,-1.5), Position(1.5,1.5), Black, true);
		W.RenderEllipse(Position(-1.5,19.5), Position(1.5,22.5), Black, true);
		W.RenderEllipse(Position(19.5,-1.5), Position(22.5,1.5), Black, true);
		W.RenderEllipse(Position(19.5,19.5), Position(22.5,22.5), Black, true);

		W.RenderRectangle(Position(21.0,0.0), Position(28.5,21.0), White, false);
		W.RenderRectangle(Position(0.0,21.0), Position(25.0,25.0), White, false);
		W.RenderLine(Position(0.0,21.0), Position(21.0,21.0), Black, 0.04);
		W.RenderLine(Position(21.0,0.0), Position(21.0,21.0), Black, 0.04);
	//White strips
		W.RenderRectangle(Position(3.0,1.5), Position(18.0,2.5), White, true);		//top
		W.RenderRectangle(Position(1.5,3.0), Position(2.5,18.0), White, true);		//Left
		W.RenderRectangle(Position(18.5,3.0), Position(19.5,18.0), White, true);	//Right
		W.RenderRectangle(Position(3.0,18.5), Position(18.0,19.5), White, true);	//Bottom
	//Red Circles
		W.RenderEllipse(Position(2.5,1.5), Position(3.5,2.5), White, true);	//top left
		W.RenderEllipse(Position(2.6,1.6), Position(3.4,2.4), Red, true);	// -- 
	
		W.RenderEllipse(Position(17.5,1.5), Position(18.5,2.5), White, true);	//top right
		W.RenderEllipse(Position(17.6,1.6), Position(18.4,2.4), Red, true);	// --

		W.RenderEllipse(Position(1.5,2.5), Position(2.5,3.5), White, true);	//Left top
		W.RenderEllipse(Position(1.6,2.6), Position(2.4,3.4), Red, true);	// --

		W.RenderEllipse(Position(1.5,17.5), Position(2.5,18.5), White, true);	//left bottom
		W.RenderEllipse(Position(1.6,17.6), Position(2.4,18.4), Red, true);	// --

		W.RenderEllipse(Position(18.5,2.5), Position(19.5,3.5), White, true);	//right top
		W.RenderEllipse(Position(18.6,2.6), Position(19.4,3.4), Red, true);	// --

		W.RenderEllipse(Position(18.5,17.5), Position(19.5,18.5), White, true);	//right bottom
		W.RenderEllipse(Position(18.6,17.6), Position(19.4,18.4), Red, true);	// --

		W.RenderEllipse(Position(2.5,18.5), Position(3.5,19.5), White, true);	//bottom left
		W.RenderEllipse(Position(2.6,18.6), Position(3.4,19.4), Red, true);	// --

		W.RenderEllipse(Position(17.5,18.5), Position(18.5,19.5), White, true);	//bottom right
		W.RenderEllipse(Position(17.6,18.6), Position(18.4,19.4), Red, true);	// --
	//CENTRE
		W.RenderEllipse(Position(7.5,7.5), Position(13.5,13.5),White, true);
		W.RenderEllipse(Position(7.6,7.6), Position(13.4,13.4),Magenta, true);		
		W.RenderEllipse(Position(7.7,7.7), Position(13.3,13.3),White, true);
		W.RenderEllipse(Position(8.5,8.5), Position(12.5,12.5),Red, false);
		W.RenderEllipse(Position(8.7,8.7), Position(12.3,12.3),Yellow, true);
	//STAR
		W.RenderLine(Position(10.5,8.7), Position(8.9,11.3), Blue, 0.05);
		W.RenderLine(Position(10.5,8.7), Position(12.1,11.3), Blue, 0.05);
		W.RenderLine(Position(8.9,11.3), Position(12.1,11.3), Blue, 0.05);
		W.RenderLine(Position(8.9,9.7), Position(12.1,9.7), Blue, 0.05);
		W.RenderLine(Position(10.5,12.3), Position(8.9,9.7), Blue, 0.05);
		W.RenderLine(Position(10.5,12.3), Position(12.1,9.7), Blue, 0.05);
	//ARROW CIRCLES
		W.RenderEllipse(Position(3.5,3.5), Position(5.5,5.5),White, true);	//Top left
		W.RenderEllipse(Position(15.5,3.5), Position(17.5,5.5),White, true);	//Top Right
		W.RenderEllipse(Position(3.5,15.5), Position(5.5,17.5),White, true);	//Bottom left
		W.RenderEllipse(Position(15.5,15.5), Position(17.5,17.5),White, true);	//Bottom right
	//ARROW LINES
		W.RenderLine(Position(1.5,1.5), Position(4.5,4.5), Black, 0.05);	//Top left
		W.RenderLine(Position(19.5,1.5), Position(16.5,4.5), Black, 0.05);	//Top right
		W.RenderLine(Position(1.5,19.5), Position(4.5,16.5), Black, 0.05);	//Bottom left
		W.RenderLine(Position(19.5,19.5), Position(16.5,16.5), Black, 0.05);	//Bottom right
	
	//ARROW HEADS
		W.RenderLine(Position(1.5,1.5), Position(2.0,1.5), Black, 0.05);	//Top left horiz.
		W.RenderLine(Position(1.5,1.5), Position(1.5,2.0), Black, 0.05);	//Top left vert.
	
		W.RenderLine(Position(19.5,1.5), Position(19.0,1.5), Black, 0.05);	//Top right horiz.
		W.RenderLine(Position(19.5,1.5), Position(19.5,2.0), Black, 0.05);	//Top right vert.
	
		W.RenderLine(Position(1.5,19.5), Position(2.0,19.5), Black, 0.05);	//Bottom left horiz.
		W.RenderLine(Position(1.5,19.5), Position(1.5,19.0), Black, 0.05);	//Bottom left vert.
	
		W.RenderLine(Position(19.5,19.5), Position(19.0,19.5), Black, 0.05);	//Bottom right horiz.
		W.RenderLine(Position(19.5,19.5), Position(19.5,19.0), Black, 0.05);	//Bottom right vert.

	//Set Position
		W.RenderRectangle(Position(23.0,1.5), Position(27.0,3.0), Black, true);
		W.RenderRectangle(Position(23.1,1.6), Position(26.9,2.9), Black, false);
		W.RenderRectangle(Position(23.2,1.7), Position(26.8,2.8), White, true);
		W.RenderText(Position(23.0,1.5), Position(27.0,3.0),"Set Position", Red);
	
		for(i=0;i<=total_gits;i++)
		{
			if(i==0)
			{
				W.RenderEllipse(Position(x[0]-rs,y[0]-rs), Position(x[0]+rs,y[0]+rs), Cyan, true);
	//			W.RenderEllipse(Position(x[0]-rs+0.2,y[0]-rs+0.2), Position(x[0]+rs-0.2,y[0]+rs-0.2),White, false);
	//			W.RenderEllipse(Position(x[0]-rs+0.4,y[0]-rs+0.4), Position(x[0]+rs-0.4,y[0]+rs-0.4),Green, true);
			}
			else
			{
				W.RenderEllipse( Position(x[i]-rg,y[i]-rg),Position(x[i]+rg,y[i]+rg), Magenta, true);
			}
		}
	}
}
*/
	
int Input(const Position &P)
{
	xm=P.GetXDistance();
	ym=P.GetYDistance();

	if(xm>23.0 && xm<27.0 && ym>16.5 && ym<18.0)
	{
		W.Message("Thanks for Playing");
		W.Close();
	}

	if(xm>4.25 && xm<16.75 && ym>1.75 && ym<2.25 && k==0)
	{
		valid=chkvalid();
		
		if(valid==1)
		{
			x[0]=xm-rs;
			y[0]=ym-rs;
		}
		else
		{
			x[0]=10.5;	y[0]=2.0;
		}
		Carrom_Display();
		return 1;	
	}

	if(k==0)
	{
		if(xm>4.25 && xm<16.75 && ym>1.75 && ym<2.25)	// x & y both inside the strip
		{
			x[0]=P.GetXDistance();	y[0]=P.GetYDistance();
		}
	
		else if(xm<=04.25)	//x left of the strip
		{
			x[0]=3.0;	y[0]=2.0;
		}

		else if(xm>=16.75 && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x right of the strip
		{
			x[0]=18.0;	y[0]=2.0;
		}

		else if(xm>04.25 && xm<16.75 && ym<=1.75 && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x inside & y up the strip
		{
			x[0]=P.GetXDistance();	y[0]=1.75;
		}

		else if(xm>04.25 && xm<16.75 && ym>=2.25 && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x inside & y down the strip
		{
			x[0]=P.GetXDistance();	y[0]=2.25;
		}
	
		else if(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0)
		{
			k=1;
		}
		Carrom_Display();
		return 1;	
	}
	
	if(k==1 && ym>y[0])
	{
		dist=sqrt(pow((xm-x[0]),2)+pow((ym-y[0]),2));
		vel=powfact*2*dist;
		b=atan((ym-y[0])/(xm-x[0]));
		if(b<0)
			b=b+pi;
		vx[0]=vel*cos(b);
		vy[0]=vel*sin(b);
	
		int flag=1;
	
		while(flag==1)
		{
			flag=0;
			Move();
			Collision();

			for(long int z=0;z<2200000;z++);
	
			for(int i=0;i<=total_gits;i++)
			{
				if((abs(vx[i])>0.0001)||abs(vy[i])>0.0001)
				{
					flag=1;
					break;
				}
			}
		}
		Carrom_Display();
	}
	return 1;
}

int chkvalid()
{
	valid=1;
	disp=0;

	for(i=1;i<=total_gits;i++)
	{		
		if(double(pow(double(pow((x[i]-xm-rs),2))+(double(pow((y[i]-ym-rs),2))),0.5))<rg+rs)
		valid=0;
		//Rendertext to display appropriate message to the user stating the reason for input to be invalid
	}

	while(collisions==0)
	{
		Move();
		Collision();
	}
	if(abs(ccy+rg-1.5)<rg || abs(ccy+rg-2.5)<rg) 
		valid=0; 

	disp=1;
	return valid;
}

void Move()
{
	i=0;
	r=rs;
	for(i=0;i<=total_gits;i++)
	{
		W.RenderEllipse( Position(x[i]-r,y[i]-r),Position(x[i]+r,y[i]+r), White, false);
		x[i]+=vx[i];
		if(x[i]-r<0)
			x[i]=r;
		if(x[i]>21-r)
			x[i]=21-r;

		y[i]+=vy[i];
		if(y[i]-r<0)
			y[i]=r;
		if(y[i]>21-r)
			y[i]=21-r;

		W.RenderEllipse( Position(x[i]-r,y[i]-r),Position(x[i]+r,y[i]+r), Blue, false);
		
//		Carrom_Display();
		
		if(vx[i]==0 && vy[i]==0)
		{
			r=rg;
			continue;
		}

		if((vx[i]*(vx[i]-ACCL*vx[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)))))<=0)
		vx[i]=0;
		else
		vx[i]-=ACCL*vx[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)));

		if((vy[i]*(vy[i]-ACCL*vy[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)))))<=0)
		vy[i]=0;
		else
		vy[i]-=ACCL*vy[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)));
		r=rg;
	}
}



int Collision()
{
	collisions=0;
	int i=0,j;
	float T,Pn,vi_n,vj_n,vi_t,vj_t;
	float d=rg+rs, M=MS, m=MG,r=rs,cx,cy;
	float D;
	do
	{
		for(j=i+1;j<20;j++)
		{
			D=double(pow(double(pow((x[i]-x[j]),2))+(double(pow((y[i]-y[j]),2))),0.5));
			if(D<d)
			{
					T=atan((y[i]-y[j])/(x[i]-x[j]));
					cx=(x[i]+x[j])/2;
					cy=(y[i]+y[j])/2;
					
					x[i]=cx+r*abs(cos(T))*(x[i]-cx)/abs(x[i]-cx);
					x[j]=cx+r*abs(cos(T))*(x[j]-cx)/abs(x[j]-cx);
					y[i]=cy+r*abs(sin(T))*(y[i]-cy)/abs(y[i]-cy);
					y[j]=cy+r*abs(sin(T))*(y[j]-cy)/abs(y[j]-cy);
					
					Carrom_Display();
					
					vi_n=vx[i]*cos(T)+vy[i]*sin(T);
					vi_t=vy[i]*cos(T)-vx[i]*sin(T);
					vj_n=vx[j]*cos(T)+vy[j]*sin(T);
					vj_t=vy[j]*cos(T)-vx[j]*sin(T);
					Pn= m*vj_n + M*vi_n;

					vi_n=(Pn-m*E*(vi_n-vj_n))/(M+m);
					vj_n=(Pn-M*E*(vj_n-vi_n))/(M+m);

					vx[j]=vj_n*cos(T)-vj_t*sin(T);
					vy[j]=vj_t*cos(T)+vj_n*sin(T);
					vx[i]=vi_n*cos(T)-vi_t*sin(T);
					vy[i]=vi_t*cos(T)+vi_n*sin(T);
					
					collisions++;
					ccx=x[j];
					ccy=y[j];
					
			}			
		}
		
		if (y[i]-r==0 || (y[i]+r)==21)
		{
			vy[i]=-E*vy[i];
			collisions++;
		}
		if (x[i]-r==0 || (x[i]+r)==21)
		{
			vx[i]=-E*vx[i];
			collisions++;
		}

		
		i++;
		d=2*rg;
		r=rg;
		M=MG;
	}
	while(i<20);
	return collisions;
}

