//	export gl='g++ -lGL -lGLU -lglut'
//	$gl filename.cpp
//	./a.out


/*
To install openGl
	$ sudo apt-get install freeglut (freeglut3)
*/

#include <cmath>
#include <cstdlib>
#include <iostream>
#include <GL/glut.h>
using namespace std;

int win_width = 512;
int win_height = 512;
bool toggle = false;

void display( void )
{
  glClear( GL_COLOR_BUFFER_BIT );

  if(toggle) {
    glColor3f(1.0f, 1.0f, 1.0f);
    glBegin(GL_POLYGON);
    glVertex2f(0.1f, 0.1f);
    glVertex2f(0.5f, 0.1f);
    glVertex2f(0.5f, 0.5f);
    glVertex2f(0.1f, 0.5f);
    glEnd();
  }

  glutSwapBuffers();
}


void reshape( int w, int h )
{
  if  ( h == 0 ) h = 1;g++ -lGL -lGLU -lglut
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  glOrtho( 0.0, (GLdouble)w, 0.0, (GLdouble)h, -1., 1. );
  glViewport( 0, 0, w, h );
  win_width = w;
  win_height = h;
  glutPostRedisplay();
}

void keyboard( unsigned char key, int x, int y ) {
  switch(key) {
  case 27:
    exit(0);
    break;
  case '1':
    cout<<"Pressed Key: 1"<<endl;
    break;
  case '2':
    cout<<"Pressed Key: 2"<<endl;
    break;
  case '3':
    cout<<"Pressed Key: 3"<<endl;
    break;

  default:
    cout<<"Default Key"<<endl;
    break;
  }
}

void mouse(int button, int state, int x, int y)
{
  if (button == GLUT_LEFT_BUTTON) {
    if(toggle)
      toggle = false;
    else
      toggle = true;
  }
  glutPostRedisplay();
}


int main (int argc, char *argv[])
{

  glutInit( &argc, argv );
  glutInitDisplayMode( GLUT_RGBA | GLUT_DOUBLE );
  glutInitWindowSize( win_width, win_height );

  glutCreateWindow( "Title" );

  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(keyboard);
  glutMouseFunc(mouse);

  glutIdleFunc(display);

  glutMainLoop();
  return 0;
}
