#include "ezwin.h"
#include <cassert>
#include <cmath>
#define pi 3.14159265
#define powfact 1
#define ACCL 0.00001
#define rs 0.75 //Change radius of striker after modifications
#define rg 0.5
#define MS 1
#define MG 1
#define E 0.85

int positionset=0,powerset=0,playerturn=1;
using namespace std;
SimpleWindow W("Carrom", 28.0, 21.0,Position(0.0, 0.0));
struct wcoin
	{
	float x,y,velx,vely;
	int value,player,status;
	void renderwhitecoin();
	}w[10];
struct bcoin
	{
	float x,y,velx,vely;
	int value,player,status;
	void renderblackcoin();
	}b[10];
struct striker
	{
	float x,y,velx,vely,angle;
	void renderstriker();
	}str;
struct rcoin
	{
	float x,y,velx,vely;
	int value,player,status;
	void renderqueen();
	}que;
int mainscreenmouse(const Position &P);
void mainscreen();
int gamescreenmouse(const Position &P);
void gamescreen();
void Board();

int mainscreenmouse(const Position &P)
	{
	float x,y;
	x=P.GetXDistance();
	y=P.GetYDistance();
	if(((x>=11.0)&&(x<=17.0))&&((y>=6.0)&&(y<=8.0)))
		{
		gamescreen();
		return 1;
		}
	if(((x>=11.0)&&(x<=17.0))&&((y>=10.0)&&(y<=12.0)))
		{
		instructionscreen();
		return 1;
		}
	if(((x>=11.0)&&(x<=17.0))&&((y>=14.0)&&(y<=16.0)))
		{
		highscoresscreen();
		return 1;
		}
	if(((x>=11.0)&&(x<=17.0))&&((y>=6.0)&&(y<=8.0)))
		{
		exit(0);
		return 1;
		}
	else
		mainscreen();	
	return 1;	
	}
void mainscreen()
	{
	W.Open();
	W.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);
	W.RenderRectangle(Position(11.0,6.0), Position(17.0,8.0), White, true);
	W.RenderRectangle(Position(11.0,10.0), Position(17.0,12.0), White, true);
	W.RenderRectangle(Position(11.0,14.0), Position(17.0,16.0), White, true);
	W.RenderRectangle(Position(11.0,18.0), Position(17.0,20.0), White, true);
	W.RenderText(Position(11.0,6.0),Position(17.0,8.0),"Start Game",red);
	W.RenderText(Position(11.0,10.0),Position(17.0,12.0),"Instructions",red);
	W.RenderText(Position(11.0,14.0),Position(17.0,16.0),"Highscores",red);
	W.RenderText(Position(11.0,18.0),Position(17.0,20.0),"Exit Game",red);
	W.SetMouseClickCallback(mainscreenmouse);
	}
int gamescreenmouse(const Position &P) //For power,position and angle
	{
	float x,y;
	x=P.GetXDistance();
	y=P.GetYDistance();
	if(playerturn==1)
		{
		str.y=2;
		if(postionset==0)
			{
			if(x>=2.5 && x<=18.5 && y>=1.5 && y<=2.5)
				{
				if((x-2.5)<rs)
					str.x=2.5+rs;
	            if((18.5-x)<rs)
	            	str.x=18.5-rs;
	            else
	            str.x=x;
	            }
	        if(x>=22.0 && x<=27.0 && y>=4.0 && y<=5.5)
	        {
	        positionset=1;
	        gamescreen();
	        return 1;
	        }
	        }
		if(positionset==1)
			{
			if(x>=21.0 || y<=1.5)
				{
				gamescreen();
				return 1;
				}
			if(x<=21.0 && y>=1.5)
				{
				if(y<2.0)
					y=2.0;
					if(y==2.0)
					{
						if((x-str.x)>0.0)
						str.angle=0;
						if((x-str.x)<0.0)
						str.angle=pi;
					}
					else
					{
					str.angle=atan((y-2.0)/(x-str.x));
					if(str.angle<0.0)
					str.angle=pi+str.angle;
					str.velx=pow(((x-str.x)*(x-str.x)+(y-str.y)*(y-str.y)),0.5)*cos(str.angle);
					str.vely=pow(((x-str.x)*(x-str.x)+(y-str.y)*(y-str.y)),0.5)*sin(str.angle);
					}
			if(x>=22.0 && x<=27.0 && y>=4.0 && y<=5.5)
			 		{
			 		powerset=1;
			 		}		
				}			
			}
		}
	if(playerturn==2)
		{
		str.y=19.0;
		if(positionset==0)
			{
			if(x>=2.5 && x<=18.5 && y>=18.5 && y<=19.5)
				{
				if((x-2.5)<rs)
					str.x=2.5+rs;
	            if((18.5-x)<rs)
	            	str.x=18.5-rs;
	            else
	            str.x=x;
	            }
	        if(x>=22.0 && x<=27.0 && y>=4.0 && y<=5.5)
	        {
	        positionset=1;
	        gamescreen();
	        return 1;
	        }
	        }
		if(positionset==1)
			{
			if(x>=21.0 || y>=19.5)
				{
				gamescreen();
				return 1;
				}
			if(x<=21.0 && y>=19.5)
				{
				if(y>19.0)
					y=19.0;
					if(y==19.0)
					{
						if((x-str.x)>0.0)
						str.angle=0;
						if((x-str.x)<0.0)
						str.angle=pi;
					}
					else
					{
					str.angle=atan((19.0-y)/(x-str.x));
					if(str.angle<0.0)
					str.angle=pi+str.angle;
					str.velx=pow(((x-str.x)*(x-str.x)+(y-str.y)*(y-str.y)),0.5)*cos(str.angle);
					str.vely=-pow(((x-str.x)*(x-str.x)+(y-str.y)*(y-str.y)),0.5)*sin(str.angle);
					}
			if(x>=22.0 && x<=27.0 && y>=4.0 && y<=5.5)
			 		{
			 		powerset=1;
			 		}		
				}			
			}
		}			
	}
void gamescreen()
	{
	Board();
	//W.RenderText() //For Player Turn
	W.SetMouseClickCallback(gamescreenmouse);
	W.RenderRectangle(Position(22.0,4.0),Position(27.0,5.5),White,true);
	W.RenderText(Position(22.0,4.0),Position(27.0,5.5),"Set Position",Red);
	//W.RenderText(Position();
	if(positionset==1)			//To intialize power input
		{
		W.RenderRectangle(Position(22.0,4.0),Position(27.0,5.5),White,true);
		W.RenderText(Position(22.0,4.0),Position(27.0,5.5),"Set Power And Angle",Red);
		}
	if(positionset==1&&powerset==1)		//To Pass onto collisions and animation	
	 	{
	 	                             //Function call for animation and physics
	 	positionset=powerset=0;		//Reinitalizing for next set of inputs
	 	}
	W.SetMouseClickCallback(gamescreenmouse); 		 	
	}
int endgamescreenmouse(const Position &P)
	{}
void endgamescreen()
	{}
int instructionscreenmouse(const Position &P)
	{}
void instructionscreen()
	{}
int instructionscreen(const Position &P)
	{}
void highscoresscreen()
	{}		
			

void Board()
{
	W.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);	//White Background
//Holes
	W.RenderEllipse(Position(-1.5,-1.5), Position(1.5,1.5), Black, true);
	W.RenderEllipse(Position(-1.5,19.5), Position(1.5,22.5), Black, true);
	W.RenderEllipse(Position(19.5,-1.5), Position(22.5,1.5), Black, true);
	W.RenderEllipse(Position(19.5,19.5), Position(22.5,22.5), Black, true);

	W.RenderRectangle(Position(21.0,0.0), Position(28.5,21.0), White, false);
	W.RenderRectangle(Position(0.0,21.0), Position(25.0,25.0), White, false);
	W.RenderLine(Position(0.0,21.0), Position(21.0,21.0), Black, 0.04);
	W.RenderLine(Position(21.0,0.0), Position(21.0,21.0), Black, 0.04);
//White strips
	W.RenderRectangle(Position(3.0,1.5), Position(18.0,2.5), White, true);	//top
	W.RenderRectangle(Position(1.5,3.0), Position(2.5,18.0), White, true);	//Left
	W.RenderRectangle(Position(18.5,3.0), Position(19.5,18.0), White, true);	//Right
	W.RenderRectangle(Position(3.0,18.5), Position(18.0,19.5), White, true);	//Bottom
//Red Circles
	W.RenderEllipse(Position(2.5,1.5), Position(3.5,2.5), White, true);	//top left
	W.RenderEllipse(Position(2.6,1.6), Position(3.4,2.4), Red, true);	// -- 

	W.RenderEllipse(Position(17.5,1.5), Position(18.5,2.5), White, true);	//top right
	W.RenderEllipse(Position(17.6,1.6), Position(18.4,2.4), Red, true);	// --

	W.RenderEllipse(Position(1.5,2.5), Position(2.5,3.5), White, true);	//Left top
	W.RenderEllipse(Position(1.6,2.6), Position(2.4,3.4), Red, true);	// --

	W.RenderEllipse(Position(1.5,17.5), Position(2.5,18.5), White, true);	//left bottom
	W.RenderEllipse(Position(1.6,17.6), Position(2.4,18.4), Red, true);	// --

	W.RenderEllipse(Position(18.5,2.5), Position(19.5,3.5), White, true);	//right top
	W.RenderEllipse(Position(18.6,2.6), Position(19.4,3.4), Red, true);	// --

	W.RenderEllipse(Position(18.5,17.5), Position(19.5,18.5), White, true);	//right bottom
	W.RenderEllipse(Position(18.6,17.6), Position(19.4,18.4), Red, true);	// --

	W.RenderEllipse(Position(2.5,18.5), Position(3.5,19.5), White, true);	//bottom left
	W.RenderEllipse(Position(2.6,18.6), Position(3.4,19.4), Red, true);	// --

	W.RenderEllipse(Position(17.5,18.5), Position(18.5,19.5), White, true);	//bottom right
	W.RenderEllipse(Position(17.6,18.6), Position(18.4,19.4), Red, true);	// --
//CENTRE
	W.RenderEllipse(Position(7.5,7.5), Position(13.5,13.5),White, true);
	W.RenderEllipse(Position(7.6,7.6), Position(13.4,13.4),Magenta, true);		
	W.RenderEllipse(Position(7.7,7.7), Position(13.3,13.3),White, true);
	W.RenderEllipse(Position(8.5,8.5), Position(12.5,12.5),Red, false);
	W.RenderEllipse(Position(8.7,8.7), Position(12.3,12.3),Yellow, true);
//STAR
	W.RenderLine(Position(10.5,8.7), Position(8.9,11.3), Blue, 0.05);
	W.RenderLine(Position(10.5,8.7), Position(12.1,11.3), Blue, 0.05);
	W.RenderLine(Position(8.9,11.3), Position(12.1,11.3), Blue, 0.05);
	W.RenderLine(Position(8.9,9.7), Position(12.1,9.7), Blue, 0.05);
	W.RenderLine(Position(10.5,12.3), Position(8.9,9.7), Blue, 0.05);
	W.RenderLine(Position(10.5,12.3), Position(12.1,9.7), Blue, 0.05);

	W.RenderEllipse(Position(3.5,3.5), Position(5.5,5.5),White, true);
	W.RenderEllipse(Position(15.5,3.5), Position(17.5,5.5),White, true);
	W.RenderEllipse(Position(3.5,15.5), Position(5.5,17.5),White, true);
	W.RenderEllipse(Position(15.5,15.5), Position(17.5,17.5),White, true);
//ARROWS
	W.RenderLine(Position(1.5,1.5), Position(4.5,4.5), Black, 0.05);
	W.RenderLine(Position(19.5,1.5), Position(16.5,4.5), Black, 0.05);
	W.RenderLine(Position(1.5,19.5), Position(4.5,16.5), Black, 0.05);
	W.RenderLine(Position(19.5,19.5), Position(16.5,16.5), Black, 0.05);
//Coins
	for(int i=0;i<10;i++)
		{
		w[i].renderwhitecoin();
		b[i].renderblackcoin();
		}
	que.renderqueen();
	str.renderstriker();	
}
int ApiMain()
     {
     gamescreen();
     }

