#define ACCL 0.0006
#define rs 0.75 //Change radius of striker after modifications
#define rg 0.5
#define r 0.5
#define MS 1
#define MG 1
#define total_gits 7
#define powfact 0.02
#define pi 3.14159265
#define E 0.85


#include "ezwin.h"
#include <cassert>
#include <cmath>
#include <iostream>
#include <cstring>
#include "Alert.h"

using namespace std;

SimpleWindow Start("Game",28.0,21.0, Position(0.5,0.5));
SimpleWindow W("CARROM", 28.0, 21, Position(0.5, 0.5));
SimpleWindow Help("Instrcutions", 28.0, 21, Position(0.5, 0.5));

struct whitecoins
	{
	double x,y,vx,vy;
	int status,player,thisturn;
	void rendercoin()
		{
		W.RenderEllipse(Position(x-rg,y-rg),Position(x+rg,y+rg),Magenta,true);
		}
	void initialize()
		{
		status=1;
		player=-1;
		thisturn=0;
		}	
	};
	
struct blackcoins
	{
	double x,y,vx,vy;
	int status,player,thisturn;
	void rendercoin()
		{
		W.RenderEllipse(Position(x-rg,y-rg),Position(x+rg,y+rg),Black,true);
		}
	void initialize()
		{
		status=1;
		player=-1;
		thisturn=0;
		}	
	};
		
struct queen
	{
	double x,y,vx,vy;
	int status,player,thisturn,previousturn;
	void rendercoin()
		{
		W.RenderEllipse(Position(x-rg,y-rg),Position(x+rg,y+rg),Red,true);
		}
	void initialize()
		{
		previousturn=0;
		status=1;
		player=-1;
		thisturn=0;
		}	
	};

struct striker
	{
	double x,y,vx,vy;
	int thisturn,player,status;
	void rendercoin()
		{
		W.RenderEllipse(Position(x-rs,y-rs), Position(x+rs,y+rs), Cyan, true);
		W.RenderEllipse(Position(x-rs+0.2,y-rs+0.2), Position(x+rs-0.2,y+rs-0.2),White, false);
		W.RenderEllipse(Position(x-rs+0.4,y-rs+0.4), Position(x+rs-0.4,y+rs-0.4),Green, true);			
		}
	};

whitecoins w[total_gits/2];	//Declaration of coins
blackcoins b[total_gits/2];		
queen que;
striker str;

int i,k=0,disp=1,valid,collisions=0,validpos=0,queen=0,tobeSet,cp=0,due=0,locked=0;
double xm,ym,dist,angle,vel,cvspx,cvspy;
double ccx=-10,ccy=-10,len=0;


void collide(double *ax,double *ay,double *avx,double *avy,double *bx,double *by,double *bvx,double *bvy,double d,double rad);
void startscreen();
int statrscreenmouse(const Position &P);
void gamescreen();
int gamescreenmouse(const Position &P);
void chkoverlap();
void chkdirection();
void Move();
void checkstop();



	



void Carrom_Display()
{
	W.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);	//White Background
//Holes
	W.RenderEllipse(Position(-1.5,-1.5), Position(1.5,1.5), Black, true);
	W.RenderEllipse(Position(-1.5,19.5), Position(1.5,22.5), Black, true);
	W.RenderEllipse(Position(19.5,-1.5), Position(22.5,1.5), Black, true);
	W.RenderEllipse(Position(19.5,19.5), Position(22.5,22.5), Black, true);

	W.RenderRectangle(Position(21.0,0.0), Position(28.5,21.0), White, false);
	W.RenderRectangle(Position(0.0,21.0), Position(25.0,25.0), White, false);
	W.RenderLine(Position(0.0,21.0), Position(21.0,21.0), Black, 0.04);
	W.RenderLine(Position(21.0,0.0), Position(21.0,21.0), Black, 0.04);
//White strips
	W.RenderRectangle(Position(3.0,1.5), Position(18.0,2.5), White, true);		//top
	W.RenderRectangle(Position(1.5,3.0), Position(2.5,18.0), White, true);		//Left
	W.RenderRectangle(Position(18.5,3.0), Position(19.5,18.0), White, true);	//Right
	W.RenderRectangle(Position(3.0,18.5), Position(18.0,19.5), White, true);	//Bottom
//Red Circles
	W.RenderEllipse(Position(2.5,1.5), Position(3.5,2.5), White, true);	//top left
	W.RenderEllipse(Position(2.6,1.6), Position(3.4,2.4), Red, true);	// -- 

	W.RenderEllipse(Position(17.5,1.5), Position(18.5,2.5), White, true);	//top right
	W.RenderEllipse(Position(17.6,1.6), Position(18.4,2.4), Red, true);	// --

	W.RenderEllipse(Position(1.5,2.5), Position(2.5,3.5), White, true);	//Left top
	W.RenderEllipse(Position(1.6,2.6), Position(2.4,3.4), Red, true);	// --

	W.RenderEllipse(Position(1.5,17.5), Position(2.5,18.5), White, true);	//left bottom
	W.RenderEllipse(Position(1.6,17.6), Position(2.4,18.4), Red, true);	// --

	W.RenderEllipse(Position(18.5,2.5), Position(19.5,3.5), White, true);	//right top
	W.RenderEllipse(Position(18.6,2.6), Position(19.4,3.4), Red, true);	// --

	W.RenderEllipse(Position(18.5,17.5), Position(19.5,18.5), White, true);	//right bottom
	W.RenderEllipse(Position(18.6,17.6), Position(19.4,18.4), Red, true);	// --

	W.RenderEllipse(Position(2.5,18.5), Position(3.5,19.5), White, true);	//bottom left
	W.RenderEllipse(Position(2.6,18.6), Position(3.4,19.4), Red, true);	// --

	W.RenderEllipse(Position(17.5,18.5), Position(18.5,19.5), White, true);	//bottom right
	W.RenderEllipse(Position(17.6,18.6), Position(18.4,19.4), Red, true);	// --
//CENTRE
	W.RenderEllipse(Position(7.5,7.5), Position(13.5,13.5),White, true);
	W.RenderEllipse(Position(7.6,7.6), Position(13.4,13.4),Magenta, true);		
	W.RenderEllipse(Position(7.7,7.7), Position(13.3,13.3),White, true);
	W.RenderEllipse(Position(8.5,8.5), Position(12.5,12.5),Red, false);
	W.RenderEllipse(Position(8.7,8.7), Position(12.3,12.3),Yellow, true);
//STAR
	W.RenderLine(Position(10.5,8.7), Position(8.9,11.3), Black, 0.05);
	W.RenderLine(Position(10.5,8.7), Position(12.1,11.3), Black, 0.05);
	W.RenderLine(Position(8.9,11.3), Position(12.1,11.3), Black, 0.05);
	W.RenderLine(Position(8.9,9.7), Position(12.1,9.7), Black, 0.05);
	W.RenderLine(Position(10.5,12.3), Position(8.9,9.7), Black, 0.05);
	W.RenderLine(Position(10.5,12.3), Position(12.1,9.7), Black, 0.05);
//ARROW CIRCLES
	W.RenderEllipse(Position(3.5,3.5), Position(5.5,5.5),White, true);	//Top left
	W.RenderEllipse(Position(15.5,3.5), Position(17.5,5.5),White, true);	//Top Right
	W.RenderEllipse(Position(3.5,15.5), Position(5.5,17.5),White, true);	//Bottom left
	W.RenderEllipse(Position(15.5,15.5), Position(17.5,17.5),White, true);	//Bottom right
//ARROW LINES
	W.RenderLine(Position(1.5,1.5), Position(4.5,4.5), Black, 0.05);	//Top left
	W.RenderLine(Position(19.5,1.5), Position(16.5,4.5), Black, 0.05);	//Top right
	W.RenderLine(Position(1.5,19.5), Position(4.5,16.5), Black, 0.05);	//Bottom left
	W.RenderLine(Position(19.5,19.5), Position(16.5,16.5), Black, 0.05);	//Bottom right

//ARROW HEADS
	W.RenderLine(Position(1.5,1.5), Position(2.0,1.5), Black, 0.05);	//Top left horiz.
	W.RenderLine(Position(1.5,1.5), Position(1.5,2.0), Black, 0.05);	//Top left vert.

	W.RenderLine(Position(19.5,1.5), Position(19.0,1.5), Black, 0.05);	//Top right horiz.
	W.RenderLine(Position(19.5,1.5), Position(19.5,2.0), Black, 0.05);	//Top right vert.

	W.RenderLine(Position(1.5,19.5), Position(2.0,19.5), Black, 0.05);	//Bottom left horiz.
	W.RenderLine(Position(1.5,19.5), Position(1.5,19.0), Black, 0.05);	//Bottom left vert.

	W.RenderLine(Position(19.5,19.5), Position(19.0,19.5), Black, 0.05);	//Bottom right horiz.
	W.RenderLine(Position(19.5,19.5), Position(19.5,19.0), Black, 0.05);	//Bottom right vert.

//Set Position
	W.RenderRectangle(Position(23.0,1.5), Position(27.0,3.0), Black, true);
	W.RenderRectangle(Position(23.1,1.6), Position(26.9,2.9), Black, false);
	W.RenderRectangle(Position(23.2,1.7), Position(26.8,2.8), White, true);
	W.RenderText(Position(23.0,1.5), Position(27.0,3.0),"Set Position", Red);
//Quit Game
	W.RenderRectangle(Position(23.0,16.5), Position(27.0,18.0), Black, true);
	W.RenderRectangle(Position(23.1,16.6), Position(26.9,17.9), Black, false);
	W.RenderRectangle(Position(23.2,16.7), Position(26.8,17.8), White, true);
	W.RenderText(Position(23.0,16.5), Position(27.0,18.0),"Quit Game", Red);


	for(i=0;i<=total_gits/2;i++)
	{
	w[i].rendercoin();	
	b[i].rendercoin();	
	}
	str.rendercoin();
	que.rendercoin();
	
}



int ApiMain()
	{
	for(int i=0;i<total_gits/2;i++)
		{
		w[i].initialize();
		b[i].initialize();
		}
	que.initialize();
	str.thisturn=0;
	str.player=-1;
	str.status=1;
	startscreen();		
		
	}	
		
void startscreen()
	{
	Start.Open();
	
	Start.RenderRectangle(Position(12.0,2.0), Position(16.0,3.0),White, true);
	Start.RenderText(Position(12.0,2.0), Position(16.0,3.0), "START GAME", Red);

	Start.RenderRectangle(Position(12.0,5.0), Position(16.0,6.0),White, true);
	Start.RenderText(Position(12.0,5.0), Position(16.0,6.0), "HELP", Red);

	Start.RenderRectangle(Position(12.0,8.0), Position(16.0,9.0),White, true);
	Start.RenderText(Position(12.0,8.0), Position(16.0,9.0), "EXIT", Red);

	Start.SetMouseClickCallback(statrscreenmouse);
	}

int statrscreenmouse(const Position &P)
	{
	xm=P.GetXDistance();
	ym=P.GetYDistance();
	k=3;
	if(xm>=12.0 && xm<=16.0 && ym>=2.0 && ym<=3.0)
	{
		que.x=10.5;    			que.y=10.5;

		b[1].x=10.5+2*rg*cos(pi/3);    	b[1].y=10.5+2*rg*sin(pi/3);
		b[2].x=10.5+2*rg*cos(pi/3);    	b[2].y=10.5-2*rg*sin(pi/3);
		b[0].x=10.5-2*rg;    		b[0].y=10.5;
		w[1].x=10.5-2*rg*cos(pi/3);    	w[1].y=10.5-2*rg*sin(pi/3);
		w[2].x=10.5-2*rg*cos(pi/3);    	w[2].y=10.5+2*rg*sin(pi/3);
		w[0].x=10.5+2*rg;    		w[0].y=10.5;
		gamescreen();	
	}

	else if(xm>=12.0 && xm<=16.0 && ym>=5.0 && ym<=6.0)
	{
		Help.Open();
		//Instruct();
		//Help.SetMouseClickCallback(help_game);
	}

	else if(xm>=12.0 && xm<=16.0 && ym>=8.0 && ym<=9.0)
		Start.Close();

	return 1;
}	
	
	
void gamescreen()
	{
		Start.Close();
		W.Open();
		//Loading();
		Carrom_Display();
		W.Message("Player 1's turn");
		W.SetMouseClickCallback(gamescreenmouse);
	}


int gamescreenmouse(const Position &P)
		{
		xm=P.GetXDistance();
		ym=P.GetYDistance();

		if(xm>23.0 && xm<27.0 && ym>16.5 && ym<18.0)
		{
			W.Message("Thanks for Playing");
			W.Close();
		}	

		if(k==0)
		{	
			if(xm>4.25 && xm<16.75 && ym>1.75 +len && ym<2.25 + len)	// x & y both inside the strip
			{
				str.x=P.GetXDistance();	str.y=P.GetYDistance();
			}
	
			else if(xm<=04.25)	//x left of the strip
			{
				str.x=3.0;	str.y=2.0+len;
			}

			else if(xm>=16.75 && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x right of the strip
			{
				str.x=18.0;	str.y=2.0+len;
			}

			else if(xm>04.25 && xm<16.75 && ym<=1.75 + len && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x inside & y up the strip
			{
				str.x=P.GetXDistance();	str.y=1.75+len;
			}

			else if(xm>04.25 && xm<16.75 && ym>=2.25+len && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x inside & y down the strip
			{
				str.x=P.GetXDistance();	str.y=2.25+len;
			}
	
			else if(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0 && validpos!=0)
				k=1;

			chkoverlap();
		
			Carrom_Display();
		
			return 1;	
		}
	
		if(k==1)
		{
			if((cp==0 && ym>str.y)||(cp==1 && ym<str.y))
			{
			dist=sqrt(pow((xm-str.x),2)+pow((ym-str.y),2));
			vel=powfact*2*dist;
			angle=atan((ym-str.y)/(xm-str.x));
			if(b<0 && cp==0)
				angle=angle+pi;
			if(b>0 && cp==1)
				angle=angle-pi;
			str.vx=vel*cos(angle);
			str.vy=vel*sin(angle);
			//chkdirection();
		
			if(valid)
			{	
				for(i=1;i<=total_gits/2;i++)
				{
					b[i].vx=b[i].vy=0;
					w[i].vx=w[i].vy=0;
				}
				str.vx=vel*cos(angle);
				str.vy=vel*sin(angle);
			
				int flag=1;
			
				while(flag==1)
				{
					flag=0;
					Move();
					for(int col1=0;col1<total_gits/2;col1++)
						{
						collide(&str.x,&str.y,&str.vx,&str.vy,&b[col1].x,&b[col1].y,&b[col1].vx,&b[col1].vy,(rs+rg),rs);
						collide(&str.x,&str.y,&str.vx,&str.vy,&w[col1].x,&w[col1].y,&w[col1].vx,&w[col1].vy,(rs+rg),rs);
						collide(&que.x,&que.y,&que.vx,&que.vy,&b[col1].x,&b[col1].y,&b[col1].vx,&b[col1].vy,(rg+rg),rg);
						collide(&que.x,&que.y,&que.vx,&que.vy,&w[col1].x,&w[col1].y,&w[col1].vx,&w[col1].vy,(rg+rg),rg);
						for(int col2=col1+1;col2<total_gits/2;col2++)
							{
							collide(&b[col1].x,&b[col1].y,&b[col1].vx,&b[col1].vy,&w[col2].x,&w[col2].y,&w[col2].vx,&w[col2].vy,(rg+rg),rg);
							collide(&w[col1].x,&w[col1].y,&w[col1].vx,&w[col1].vy,&b[col2].x,&b[col2].y,&b[col2].vx,&b[col2].vy,(rg+rg),rg);
							collide(&w[col1].x,&w[col1].y,&w[col1].vx,&w[col1].vy,&w[col2].x,&w[col2].y,&w[col2].vx,&w[col2].vy,(rg+rg),rg);
							collide(&b[col1].x,&b[col1].y,&b[col1].vx,&b[col1].vy,&b[col2].x,&b[col2].y,&b[col2].vx,&b[col2].vy,(rg+rg),rg);
							}
						}
					for(long int z=0;z<220000000;z++);
			
					for(int i=0;i<=total_gits/2;i++)
					{
						if((abs(w[i].vx)>0.0001)||abs(w[i].vy)>0.0001)
						{
							flag=1;
							break;
						}
						if((abs(b[i].vx)>0.0001)||abs(b[i].vy)>0.0001)
						{
							flag=1;
							break;
						}
					}
				}
				checkstop();
				Carrom_Display();
				k=0;
			}
			}
		}
	
		if(k==3)
		{
		//Set(tobeSet);	
		k=0;
		}
	
	return 1;
	}		
	

void chkoverlap()
{
	valid=1;
	for(i=1;i<=total_gits/2;i++)
	{		
		if(double(pow(double(pow((b[1].x-str.x),2))+(double(pow((b[1].y-str.y),2))),0.5))<rg+rs)
		valid=0;
		//Rendertext to display appropriate message to the user stating the reason for input to be invalid
	}
	
	if(valid==0)
		if(validpos)
		{
			str.x=cvspx;
			str.y=cvspy;
		}
		else
		{
			str.x=-10;
			str.y=-10;
		}
	
	if(valid==1)
		{
			cvspx=str.x;
			cvspy=str.y;
			validpos++;
		}
}	
	
	
void chkdirection()
{
	disp=0;
	valid=1;
	while(collisions==0)
	{
		Move();
		for(int col1=0;col1<total_gits/2;col1++)
						{
						collide(&str.x,&str.y,&str.vx,&str.vy,&b[col1].x,&b[col1].y,&b[col1].vx,&b[col1].vy,(rs+rg),rs);
						collide(&str.x,&str.y,&str.vx,&str.vy,&w[col1].x,&w[col1].y,&w[col1].vx,&w[col1].vy,(rs+rg),rs);
						collide(&que.x,&que.y,&que.vx,&que.vy,&b[col1].x,&b[col1].y,&b[col1].vx,&b[col1].vy,(rg+rg),rg);
						collide(&que.x,&que.y,&que.vx,&que.vy,&w[col1].x,&w[col1].y,&w[col1].vx,&w[col1].vy,(rg+rg),rg);
						for(int col2=col1+1;col2<total_gits/2;col2++)
							{
							collide(&b[col1].x,&b[col1].y,&b[col1].vx,&b[col1].vy,&w[col2].x,&w[col2].y,&w[col2].vx,&w[col2].vy,(rg+rg),rg);
							collide(&w[col1].x,&w[col1].y,&w[col1].vx,&w[col1].vy,&b[col2].x,&b[col2].y,&b[col2].vx,&b[col2].vy,(rg+rg),rg);
							collide(&w[col1].x,&w[col1].y,&w[col1].vx,&w[col1].vy,&w[col2].x,&w[col2].y,&w[col2].vx,&w[col2].vy,(rg+rg),rg);
							collide(&b[col1].x,&b[col1].y,&b[col1].vx,&b[col1].vy,&b[col2].x,&b[col2].y,&b[col2].vx,&b[col2].vy,(rg+rg),rg);
							}
						}	
	}
	if(abs(ccy-(1.5+len))<rg || abs(ccy-(2.5+len))<rg) 
		valid=0;
	
	
		str.x=cvspx;
		str.y=cvspy;
	disp=1;
			
	
}

void Move()
{
	i=0;
	for(i=0;i<=total_gits/2;i++)
	{
	
		if(((b[i].x*b[i].x)+(b[i].y*b[i].y)<2.25)||((b[i].x*b[i].x)+((b[i].y-21)*(b[i].y-21))<2.25)||(((b[i].x-21)*(b[i].x-21))+(b[i].y*b[i].y)<2.25)||(((b[i].x-21)*(b[i].x-21))+((b[i].y-21)*(b[i].x-21))<2.25))
        	{
            	b[i].status=0;
            	b[i].player=cp;
            	b[i].thisturn=1;
            	}
            	W.RenderEllipse( Position(b[i].x-r,b[i].y-r),Position(b[i].x+r,b[i].y+r), White, false);
		b[i].x+=b[i].vx;
		if(b[i].x<r && b[i].status==1)
			b[i].x=r;
		if(b[i].x>21-r && b[i].status==1)
			b[i].x=21-r;

		b[i].y+=b[i].vy;
		if(b[i].y<r && b[i].status==1)
			b[i].y=r;
		if(b[i].y>21-r && b[i].status==1)
			b[i].y=21-r;

		b[i].rendercoin();
		if(b[i].status==1)
		{	
			if((b[i].vx*(b[i].vx-ACCL*b[i].vx/(double(pow(((double(pow(b[i].vx,2)))+(double(pow(b[i].vy,2)))),0.5)))))<=0)
			b[i].vx=0;
			else
			b[i].vx-=ACCL*b[i].vx/(double(pow(((double(pow(b[i].vx,2)))+(double(pow(b[i].vy,2)))),0.5)));

			if((b[i].vy*(b[i].vy-ACCL*b[i].vy/(double(pow(((double(pow(b[i].vx,2)))+(double(pow(b[i].vy,2)))),0.5)))))<=0)
			b[i].vy=0;
			else
			b[i].vy-=ACCL*b[i].vy/(double(pow(((double(pow(b[i].vx,2)))+(double(pow(b[i].vy,2)))),0.5)));
		}
		
	
		if(((w[i].x*w[i].x)+(w[i].y*w[i].y)<2.25)||((w[i].x*w[i].x)+((w[i].y-21)*(w[i].y-21))<2.25)||(((w[i].x-21)*(w[i].x-21))+(w[i].y*w[i].y)<2.25)||(((w[i].x-21)*(w[i].x-21))+((w[i].y-21)*(w[i].x-21))<2.25))
        	{
            	w[i].status=0;
            	w[i].player=cp;
            	w[i].thisturn=1;
            	}
            	W.RenderEllipse( Position(w[i].x-r,w[i].y-r),Position(w[i].x+r,w[i].y+r), White, false);
		w[i].x+=w[i].vx;
		if(w[i].x<r && w[i].status==1)
			w[i].x=r;
		if(w[i].x>21-r && w[i].status==1)
			w[i].x=21-r;

		w[i].y+=w[i].vy;
		if(w[i].y<r && w[i].status==1)
			w[i].y=r;
		if(w[i].y>21-r && w[i].status==1)
			w[i].y=21-r;

		w[i].rendercoin();
		if(w[i].status==1)
		{	
			if((w[i].vx*(w[i].vx-ACCL*w[i].vx/(double(pow(((double(pow(w[i].vx,2)))+(double(pow(w[i].vy,2)))),0.5)))))<=0)
			w[i].vx=0;
			else
			w[i].vx-=ACCL*w[i].vx/(double(pow(((double(pow(w[i].vx,2)))+(double(pow(w[i].vy,2)))),0.5)));

			if((w[i].vy*(w[i].vy-ACCL*w[i].vy/(double(pow(((double(pow(w[i].vx,2)))+(double(pow(w[i].vy,2)))),0.5)))))<=0)
			w[i].vy=0;
			else
			w[i].vy-=ACCL*w[i].vy/(double(pow(((double(pow(w[i].vx,2)))+(double(pow(w[i].vy,2)))),0.5)));
		}
		
	
	
	}


	if(((que.x*que.x)+(que.y*que.y)<2.25)||((que.x*que.x)+((que.y-21)*(que.y-21))<2.25)||(((que.x-21)*(que.x-21))+(que.y*que.y)<2.25)||(((que.x-21)*(que.x-21))+((que.y-21)*(que.x-21))<2.25))
        	{
            	que.status=0;
            	que.player=cp;
            	que.thisturn=1;
            	}
            	W.RenderEllipse( Position(que.x-r,que.y-r),Position(que.x+r,que.y+r), White, false);
		que.x+=que.vx;
		if(que.x<r && que.status==1)
			que.x=r;
		if(que.x>21-r && que.status==1)
			que.x=21-r;

		que.y+=que.vy;
		if(que.y<r && que.status==1)
			que.y=r;
		if(que.y>21-r && que.status==1)
			que.y=21-r;

		que.rendercoin();
		if(que.status==1)
		{	
			if((que.vx*(que.vx-ACCL*que.vx/(double(pow(((double(pow(que.vx,2)))+(double(pow(que.vy,2)))),0.5)))))<=0)
			que.vx=0;
			else
			que.vx-=ACCL*que.vx/(double(pow(((double(pow(que.vx,2)))+(double(pow(que.vy,2)))),0.5)));

			if((que.vy*(que.vy-ACCL*que.vy/(double(pow(((double(pow(que.vx,2)))+(double(pow(que.vy,2)))),0.5)))))<=0)
			que.vy=0;
			else
			que.vy-=ACCL*que.vy/(double(pow(((double(pow(que.vx,2)))+(double(pow(que.vy,2)))),0.5)));
		}


	if(((str.x*str.x)+(str.y*str.y)<2.25)||((str.x*str.x)+((str.y-21)*(str.y-21))<2.25)||(((str.x-21)*(str.x-21))+(str.y*str.y)<2.25)||(((str.x-21)*(str.x-21))+((str.y-21)*(str.x-21))<2.25))
        	{
            	str.player=cp;
            	str.thisturn=1;
            	due=1;
            	}
            	W.RenderEllipse( Position(str.x-rg,str.y-rg),Position(str.x+rg,str.y+rg), White, false);
		str.x+=str.vx;
		if(str.x<rg && str.status==1)
			str.x=rg;
		if(str.x>21-r && str.status==1)
			str.x=21-r;

		str.y+=str.vy;
		if(str.y<rg && str.status==1)
			str.y=rg;
		if(str.y>21-rg && str.status==1)
			str.y=21-rg;

		str.rendercoin();
		if(str.status==1)
		{	
			if((str.vx*(str.vx-ACCL*str.vx/(double(pow(((double(pow(str.vx,2)))+(double(pow(str.vy,2)))),0.5)))))<=0)
			str.vx=0;
			else
			str.vx-=ACCL*str.vx/(double(pow(((double(pow(str.vx,2)))+(double(pow(str.vy,2)))),0.5)));

			if((str.vy*(str.vy-ACCL*str.vy/(double(pow(((double(pow(str.vx,2)))+(double(pow(str.vy,2)))),0.5)))))<=0)
			str.vy=0;
			else
			str.vy-=ACCL*str.vy/(double(pow(((double(pow(str.vx,2)))+(double(pow(str.vy,2)))),0.5)));
		}

}


void checkstop()
{   
    if(due==1)
    {
    W.Message("Your Punishment is due ");
    }    /*for(i=total_gits;i>1;i--)
        {
            if(possess[cp][i]==1 && this_turn[i]==1)
            k=3;
            tobeSet=i;
            possess[cp][i]=0;
        }*/
        
        /*for(i=total_gits;i>1;i--)
        {
            if(possess[cp][i]==1)
            {
            	k=3;
            	tobeSet=i;
            	possess[cp][i]=0;
            	break;
            }
        }   
     	if(i==1)
    	{
            //points deduction or whatever to be done, pls insert here.
        }
        due=0;
    }*/

    /*if(queen==1)
    {
    	for(i=total_gits;i>1;i--)
    		if(this_turn[i]==1)
    		{
    			possess[cp][1]=1;
    			queen=0;
    			break;
    		}
    	
    	if(i==1)
    	{
    		Set(1);
    		queen=0;
    	}
    }*/


    /*if(this_turn[1]==1)
        queen=1;*/

    for(i=1;i<=total_gits/2;i++)
    {
    	if(b[i].thisturn==1||w[i].thisturn==1||que.thisturn==1)
    		break;  //Queen conditions to be entered here
    }
    
    if(i==total_gits+1)
    {
    	cp=(cp+1)%2;
    }
    if(cp==0)
    {	W.Message("Player 1's Turn");
	len=0;
    }
    if(cp==1)
    {	W.Message("Player 2's Turn");
	len=17.0;
    }
   
    for(i=0;i<=total_gits/2;i++)
    b[i].thisturn=w[i].thisturn=str.thisturn=0;
    
    que.previousturn=que.thisturn=0;
    k=0;
}



/*int Set(int k)
{
	int valid=1;
	//xm=p.GetXDistance();
	//ym=p.GetYDistance();
	
	int d=sqrt(pow((xm-10.5),2)+pow((ym-10.5),2));
	
	for(i=1;i<=total_gits;i++)	
	{
		if(i!=k && sqrt(pow((xm-x[i]),2)+pow((ym-*ay),2)<2*rg))
			valid=0;
	}	


	if(d<3.0 && valid==1 && locked==1)
	{
		x[i]=xm;
		*ay=ym;
		Carrom_Display();
	}
		
	else 
		W.Message("Do it Again ");
}*/	
	
	
	
void collide(double *ax,double *ay,double *avx,double *avy,double *bx,double *by,double *bvx,double *bvy,double d,double rad)


{
double T,Pn,vi_n,vj_n,vi_t,vj_t,D,M=MS,m=MG,cx,cy;
D=double(pow(double(pow(((*ax)-(*bx)),2))+(double(pow(((*ay)-(*by)),2))),0.5));

		if(D<d)
				{
					T=atan(((*ay)-(*by))/((*ax)-(*bx)));
					cx=((*ax)*rg+(*bx)*r)/(rg+rad);
					cy=((*ay)*rg+(*by)*rad)/(rg+rad);

			
					
					*ax=cx+rad*abs(cos(T))*((*ax)-cx)/abs((*ax)-cx);
					*ay=cy+rad*abs(sin(T))*((*ay)-cy)/abs((*ay)-cy);
					*bx=cx+rg*abs(cos(T))*((*bx)-cx)/abs((*bx)-cx);
					*by=cy+rg*abs(sin(T))*((*by)-cy)/abs((*by)-cy);
					
					Carrom_Display();
					
					vi_n=(*avx)*cos(T)+(*avy)*sin(T);
					vi_t=(*avy)*cos(T)-(*avx)*sin(T);
					vj_n=(*bvx)*cos(T)+(*bvy)*sin(T);
					vj_t=(*bvy)*cos(T)-(*bvx)*sin(T);
					Pn= m*vj_n + M*vi_n;

					vi_n=(Pn-m*E*(vi_n-vj_n))/(M+m);
					vj_n=(Pn-M*E*(vj_n-vi_n))/(M+m);

					*bvx=vj_n*cos(T)-vj_t*sin(T);
					*bvy=vj_t*cos(T)+vj_n*sin(T);
					*avx=vi_n*cos(T)-vi_t*sin(T);
					*avy=vi_t*cos(T)+vi_n*sin(T);
					
					collisions++;
					ccx=*bx;
					ccy=(*by);
					
				}			
		
		if ((*ay)-r==0 || (*ay+r)==21)
		{
			*avy=-E*(*avy);
			collisions++;
		}
		if ((*ax)-r==0 || (*ax+r)==21)
		{
			*avx=-E*(*avx);
			collisions++;
		}
		if ((*by)-r==0 || (*by+r)==21)
		{
			*bvy=-E*(*bvy);
			collisions++;
		}
		if ((*bx)-r==0 || (*bx+r)==21)
		{
			*bvx=-E*(*bvx);
			collisions++;
		}
}

	
	
	
	
	
	
	
	
			
		
		
