#include "ezwin.h"
#include <cassert>
#include <cmath>
#define pi 3.14159265
#define powfact 0.005
#define ACCL 1
#define rs 0.75 //Change radius of striker after modifications
#define rg 0.5
#define MS 1
#define MG 1
#define E 0.98

using namespace std;


SimpleWindow W("Carrom", 28.0, 21.0,Position(0.0, 0.0));
float xm,ym,z,a,b,dist,vel;
int i=0,k=0;
float r=rs;
float x[20],y[20],vx[20],vy[20];

void Move();
void Collision();
void Carrom_Display();

int flag=1;

int Input(const Position &P)
{
	xm=P.GetXDistance();
	ym=P.GetYDistance();
	
	if(k==0)
	{
		if(xm>4.25 && xm<16.75 && ym>1.75 && ym<2.25)	// x & y both inside the strip
		{
			x[0]=P.GetXDistance()-rs;	y[0]=P.GetYDistance()-rs;
		}
	
		else if(xm<=04.25)	//x left of the strip
		{
			x[0]=2.25;	y[0]=1.25;
		}

		else if(xm>=16.75 && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x right of the strip
		{
			x[0]=17.25;	y[0]=1.25;
		}

		else if(xm>04.25 && xm<16.75 && ym<=1.75 && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x inside & y up the strip
		{
			x[0]=P.GetXDistance()-rs;	y[0]=1.75-rs;
		}

		else if(xm>04.25 && xm<16.75 && ym>=2.25 && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x inside & y down the strip
		{
			x[0]=P.GetXDistance()-rs;	y[0]=2.25-rs;
		}
	
		else if(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0)
		{
			k=1;
			return 1;
		}

		Carrom_Display();
		return 1;	
	}
	
	if(k==1 && ym>y[0])
	{
		dist=sqrt(pow((xm-x[0]-rs),2)+pow((ym-y[0]-rs),2));
		vel=powfact*pow(dist,2);
		b=atan((ym-y[0]-rs)/(xm-x[0]-rs));
		if(b<0)
			b=b+pi;
		vx[0]=vel*cos(b);
		vy[0]=vel*sin(b);
	
		while(flag==1)
		{
			flag=0;
			Move();
			Collision();
			for(long int z=0;z<8500000;z++);
		
			for(int i=0;i<20;i++)
			{
				if((abs(vx[i])>0.0001)||abs(vy[i])>0.0001)
				{
					flag=1;
					break;
				}
			}
		}
	}
	return 1;
}


void Move()
{
	i=0;
	r=rs;
	for(i=0;i<20;i++)
	{
//		W.RenderEllipse( Position(x[i],y[i]),Position(x[i]+2*r,y[i]+2*r), White, false);
		x[i]+=vx[i];
		if(x[i]<0)
			x[i]=0;
		if(x[i]>21-2*r)
			x[i]=21-2*r;

		y[i]+=vy[i];
		if(y[i]<0)
			y[i]=0;
		if(y[i]>21-2*r)
			y[i]=21-2*r;
//		W.RenderEllipse( Position(x[i],y[i]),Position(x[i]+2*r,y[i]+2*r), Blue, false);
		Carrom_Display();
		if(vx[i]==0 && vy[i]==0)
			continue;

		if((vx[i]*(vx[i]-ACCL*vx[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)))))<=0)
		vx[i]=0;
		else
		vx[i]-=ACCL*vx[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)));

		if((vy[i]*(vy[i]-ACCL*vy[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)))))<=0)
		vy[i]=0;
		else
		vy[i]-=ACCL*vy[i]/(double(pow(((double(pow(vx[i],2)))+(double(pow(vy[i],2)))),0.5)));
		r=rg;
		cout<<vx[0]<<endl;
	}
}



void Collision()
{
	int i=0,j;
	float T,Pn,vi_n,vj_n,vi_t,vj_t;
	float d=rg+rs, M=MS, m=MG,r=rs,cx,cy;
	float D;
	do
	{
		for(j=i+1;j<20;j++)
		{
			D=double(pow(double(pow((x[i]-x[j]),2))+(double(pow((y[i]-y[j]),2))),0.5));
			if(D<d)
				{
					T=atan((y[i]-y[j])/(x[i]-x[j]));
					cx=(x[i]+x[j])/2;
					cy=(y[i]+y[j])/2;

//					W.RenderEllipse( Position(x[i],y[i]),Position(x[i]+2*r,y[i]+2*r), White, false);
//					W.RenderEllipse( Position(x[j],y[j]),Position(x[j]+2*rg,y[j]+2*rg), White, false);
					
					x[i]=cx+r*abs(cos(T))*(x[i]-cx)/abs(x[i]-cx);
					x[j]=cx+r*abs(cos(T))*(x[j]-cx)/abs(x[j]-cx);
					y[i]=cy+r*abs(sin(T))*(y[i]-cy)/abs(y[i]-cy);
					y[j]=cy+r*abs(sin(T))*(y[j]-cy)/abs(y[j]-cy);
					
//					W.RenderEllipse( Position(x[i],y[i]),Position(x[i]+2*r,y[i]+2*r), Blue, false);
//					W.RenderEllipse( Position(x[j],y[j]),Position(x[j]+2*rg,y[j]+2*rg), Blue, false);
					Carrom_Display();

					vi_n=vx[i]*cos(T)+vy[i]*sin(T);
					vi_t=vy[i]*cos(T)-vx[i]*sin(T);
					vj_n=vx[j]*cos(T)+vy[j]*sin(T);
					vj_t=vy[j]*cos(T)-vx[j]*sin(T);
					Pn= m*vj_n + M*vi_n;

					vi_n=(Pn-m*E*(vi_n-vj_n))/(M+m);
					vj_n=(Pn-M*E*(vj_n-vi_n))/(M+m);

					vx[j]=vj_n*cos(T)-vj_t*sin(T);
					vy[j]=vj_t*cos(T)+vj_n*sin(T);
					vx[i]=vi_n*cos(T)-vi_t*sin(T);
					vy[i]=vi_t*cos(T)+vi_n*sin(T);
				}			
		}

		if (y[i]==0 || (y[i]+2*r)==21)
			vy[i]=-E*vy[i];

		if (x[i]==0 || (x[i]+2*r)==21)
			vx[i]=-E*vx[i];
		
		i++;
		d=2*rg;
		r=rg;
		M=MG;
	}
	while(i<20);
}
/*
void Carrom_Display()
{
	W.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);	//White Background
	W.RenderRectangle(Position(3.0,1.5), Position(18.0,2.5), White, true);	//top
	
	W.RenderRectangle(Position(23.0,1.5), Position(27.0,3.0), Black, true);
	W.RenderRectangle(Position(23.1,1.6), Position(26.9,2.9), Black, false);
	W.RenderRectangle(Position(23.2,1.7), Position(26.8,2.8), White, true);
	W.RenderText(Position(23.0,1.5), Position(27.0,3.0),"Set Position", Red);

	for(i=0;i<20;i++)
	{
		if(i==0)
		{
		W.RenderEllipse(Position(x[0],y[0]), Position(x[0]+2*rs,y[0]+2*rs), Cyan, true);
		W.RenderEllipse(Position(x[0]+0.2,y[0]+0.2), Position(x[0]+2*rs-0.2,y[0]+2*rs-0.2),White, false);
		W.RenderEllipse(Position(x[0]+0.4,y[0]+0.4), Position(x[0]+2*rs-0.4,y[0]+2*rs-0.4),Green, true);
		}
		else
		{
			W.RenderEllipse( Position(x[i],y[i]),Position(x[i]+2*rg,y[i]+2*rg), Magenta, true);
		}
	}
}	
*/
void Carrom_Display()
{
	W.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);	//White Background
//Holes
	W.RenderEllipse(Position(-1.5,-1.5), Position(1.5,1.5), Black, true);
	W.RenderEllipse(Position(-1.5,19.5), Position(1.5,22.5), Black, true);
	W.RenderEllipse(Position(19.5,-1.5), Position(22.5,1.5), Black, true);
	W.RenderEllipse(Position(19.5,19.5), Position(22.5,22.5), Black, true);

	W.RenderRectangle(Position(21.0,0.0), Position(28.5,21.0), White, false);
	W.RenderRectangle(Position(0.0,21.0), Position(25.0,25.0), White, false);
	W.RenderLine(Position(0.0,21.0), Position(21.0,21.0), Black, 0.04);
	W.RenderLine(Position(21.0,0.0), Position(21.0,21.0), Black, 0.04);
//White strips
	W.RenderRectangle(Position(3.0,1.5), Position(18.0,2.5), White, true);	//top
	W.RenderRectangle(Position(1.5,3.0), Position(2.5,18.0), White, true);	//Left
	W.RenderRectangle(Position(18.5,3.0), Position(19.5,18.0), White, true);	//Right
	W.RenderRectangle(Position(3.0,18.5), Position(18.0,19.5), White, true);	//Bottom
//Red Circles
	W.RenderEllipse(Position(2.5,1.5), Position(3.5,2.5), White, true);	//top left
	W.RenderEllipse(Position(2.6,1.6), Position(3.4,2.4), Red, true);	// -- 

	W.RenderEllipse(Position(17.5,1.5), Position(18.5,2.5), White, true);	//top right
	W.RenderEllipse(Position(17.6,1.6), Position(18.4,2.4), Red, true);	// --

	W.RenderEllipse(Position(1.5,2.5), Position(2.5,3.5), White, true);	//Left top
	W.RenderEllipse(Position(1.6,2.6), Position(2.4,3.4), Red, true);	// --

	W.RenderEllipse(Position(1.5,17.5), Position(2.5,18.5), White, true);	//left bottom
	W.RenderEllipse(Position(1.6,17.6), Position(2.4,18.4), Red, true);	// --

	W.RenderEllipse(Position(18.5,2.5), Position(19.5,3.5), White, true);	//right top
	W.RenderEllipse(Position(18.6,2.6), Position(19.4,3.4), Red, true);	// --

	W.RenderEllipse(Position(18.5,17.5), Position(19.5,18.5), White, true);	//right bottom
	W.RenderEllipse(Position(18.6,17.6), Position(19.4,18.4), Red, true);	// --

	W.RenderEllipse(Position(2.5,18.5), Position(3.5,19.5), White, true);	//bottom left
	W.RenderEllipse(Position(2.6,18.6), Position(3.4,19.4), Red, true);	// --

	W.RenderEllipse(Position(17.5,18.5), Position(18.5,19.5), White, true);	//bottom right
	W.RenderEllipse(Position(17.6,18.6), Position(18.4,19.4), Red, true);	// --
//CENTRE
	W.RenderEllipse(Position(7.5,7.5), Position(13.5,13.5),White, true);
	W.RenderEllipse(Position(7.6,7.6), Position(13.4,13.4),Magenta, true);		
	W.RenderEllipse(Position(7.7,7.7), Position(13.3,13.3),White, true);
	W.RenderEllipse(Position(8.5,8.5), Position(12.5,12.5),Red, false);
	W.RenderEllipse(Position(8.7,8.7), Position(12.3,12.3),Yellow, true);
//STAR
	W.RenderLine(Position(10.5,8.7), Position(8.9,11.3), Blue, 0.05);
	W.RenderLine(Position(10.5,8.7), Position(12.1,11.3), Blue, 0.05);
	W.RenderLine(Position(8.9,11.3), Position(12.1,11.3), Blue, 0.05);
	W.RenderLine(Position(8.9,9.7), Position(12.1,9.7), Blue, 0.05);
	W.RenderLine(Position(10.5,12.3), Position(8.9,9.7), Blue, 0.05);
	W.RenderLine(Position(10.5,12.3), Position(12.1,9.7), Blue, 0.05);
//ARROW CIRCLES
	W.RenderEllipse(Position(3.5,3.5), Position(5.5,5.5),White, true);	//Top left
	W.RenderEllipse(Position(15.5,3.5), Position(17.5,5.5),White, true);	//Top Right
	W.RenderEllipse(Position(3.5,15.5), Position(5.5,17.5),White, true);	//Bottom left
	W.RenderEllipse(Position(15.5,15.5), Position(17.5,17.5),White, true);	//Bottom right
//ARROW LINES
	W.RenderLine(Position(1.5,1.5), Position(4.5,4.5), Black, 0.05);	//Top left
	W.RenderLine(Position(19.5,1.5), Position(16.5,4.5), Black, 0.05);	//Top right
	W.RenderLine(Position(1.5,19.5), Position(4.5,16.5), Black, 0.05);	//Bottom left
	W.RenderLine(Position(19.5,19.5), Position(16.5,16.5), Black, 0.05);	//Bottom right

//ARROW HEADS
	W.RenderLine(Position(1.5,1.5), Position(2.0,1.5), Black, 0.05);	//Top left horiz.
	W.RenderLine(Position(1.5,1.5), Position(1.5,2.0), Black, 0.05);	//Top left vert.

	W.RenderLine(Position(19.5,1.5), Position(19.0,1.5), Black, 0.05);	//Top right horiz.
	W.RenderLine(Position(19.5,1.5), Position(19.5,2.0), Black, 0.05);	//Top right vert.

	W.RenderLine(Position(1.5,19.5), Position(2.0,19.5), Black, 0.05);	//Bottom left horiz.
	W.RenderLine(Position(1.5,19.5), Position(1.5,19.0), Black, 0.05);	//Bottom left vert.

	W.RenderLine(Position(19.5,19.5), Position(19.0,19.5), Black, 0.05);	//Bottom right horiz.
	W.RenderLine(Position(19.5,19.5), Position(19.5,19.0), Black, 0.05);	//Bottom right vert.

//Set Position
	W.RenderRectangle(Position(23.0,1.5), Position(27.0,3.0), Black, true);
	W.RenderRectangle(Position(23.1,1.6), Position(26.9,2.9), Black, false);
	W.RenderRectangle(Position(23.2,1.7), Position(26.8,2.8), White, true);
	W.RenderText(Position(23.0,1.5), Position(27.0,3.0),"Set Position", Red);

	for(i=0;i<20;i++)
	{
		if(i==0)
		{
		W.RenderEllipse(Position(x[0],y[0]), Position(x[0]+2*rs,y[0]+2*rs), Cyan, true);
		W.RenderEllipse(Position(x[0]+0.2,y[0]+0.2), Position(x[0]+2*rs-0.2,y[0]+2*rs-0.2),White, false);
		W.RenderEllipse(Position(x[0]+0.4,y[0]+0.4), Position(x[0]+2*rs-0.4,y[0]+2*rs-0.4),Green, true);
		}
		else
		{
			W.RenderEllipse( Position(x[i],y[i]),Position(x[i]+2*rg,y[i]+2*rg), Magenta, true);
		}
	}
}

//	Centre : (10.5,2.0)

int ApiMain() 
{
	W.Open();
	assert(W.GetStatus() == WindowOpen);
	x[0]=10.5-rs;	y[0]=2.0-rs;
	for(i=1;i<20;i++)
		{
			x[i]=i;
			y[i]=16;
			vx[i]=0;
			vy[i]=0;
		}
	
	Carrom_Display();

	W.SetMouseClickCallback(Input);
	
	return 0;
}

