#define ACCL 0.01
#define rs 0.5 //Change radius of striker after modifications
#define rg 0.5
#include "ezwin.h"
#include <cassert>
#include <cmath>
using namespace std;

SimpleWindow TP("Carrom", 25.5, 20, Position(0.5, 0.5));


float x[20],y[20],v[20],L[20];

void Move();
void Collision();

int ApiMain()
{
	for(int i=0;i<20;i++)
	{
	x[i]=i;
	y[i]=i;
	v[i]=0;
	}
	v[0]=1;
	L[0]=3.14159/6;


	int flag=1;
	TP.Open();
	TP.RenderLine(Position(20,0),Position(20,20),Red,0.0);
	TP.RenderRectangle(Position(20.5,1), Position(25,1.75),White, true);
	
	for(int i=0;i<20;i++)	
	TP.RenderEllipse( Position(x[i],y[i]),Position(x[i]+1,y[i]+1), Blue, true);
	

	while(flag==1)
	{
		flag=0;
		Move();
		Collision();
		for(long int z=0;z<10000000;z++);

		for(int i=0;i<20;i++)
		{
			if(v[i]!=0)
			{
				flag=1;
				break;
			}
		}
	}

return 0;
}



void Move()
{
	for(int i=0;i<20;i++)
	{
		TP.RenderEllipse( Position(x[i],y[i]),Position(x[i]+1,y[i]+1), White, false);
		x[i]+=(v[i])*cos(L[i]);
		y[i]+=(v[i])*sin(L[i]);
		TP.RenderEllipse( Position(x[i],y[i]),Position(x[i]+1,y[i]+1), Blue, false);
		v[i]-=ACCL;
		if(v[i]<0)
			v[i]=0;
	}
}



void Collision()
{
	int i=0,j;
	float d=rg+rs;

	do
	{
		for(j=i+1;j<20;j++)
		{
			if(double (pow (double(pow((x[i]-x[j]),2))+(double(pow((y[i]-y[j]),2))),0.5))<d)
				{
					if(v[j]==0)
					{
						L[j]=atan((y[i]-y[j])/(x[i]-x[j]));
						v[j]=v[i];
						v[i]=0;
					}
					else if(v[i]==0)
					{
						L[i]=atan((y[i]-y[j])/(x[i]-x[j]));
						v[i]=v[j];
						v[j]=0;
					}
				}
		}
		i++;
	}
	while(i<20);
}













