#include "ezwin.h"
#include <cassert>
#include <cmath>

SimpleWindow P("Carrom", 24.0, 21.0,Position(1.0, 1.0));

void Angle()
{
	float y;
	for(float i=-2;i<=2;i+=0.001)
	{
		y=sqrt(4-i*i);		
		P.RenderLine(Position(10.5+i,19.5-y), Position(10.5+i,19.5-y), Black, 0.035);
	}
	P.RenderLine(Position(8.5,19.45), Position(12.48,19.45), Black, 0.035);
}

void Board()
{
	P.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);
	P.RenderEllipse(Position(-1.5,-1.5), Position(1.5,1.5), Black, true);
	P.RenderEllipse(Position(-1.5,19.5), Position(1.5,22.5), Black, true);
	P.RenderEllipse(Position(19.5,-1.5), Position(22.5,1.5), Black, true);
	P.RenderEllipse(Position(19.5,19.5), Position(22.5,22.5), Black, true);
	P.RenderRectangle(Position(21.0,0.0), Position(28.5,21.0), White, false);
	P.RenderRectangle(Position(0.0,21.0), Position(25.0,25.0), White, false);
	P.RenderLine(Position(0.0,21.0), Position(21.0,21.0), Black, 0.04);
	P.RenderLine(Position(21.0,0.0), Position(21.0,21.0), Black, 0.04);

	P.RenderRectangle(Position(3.0,1.0), Position(18.0,2.0), Red, true);
	P.RenderRectangle(Position(1.0,3.0), Position(2.0,18.0), Red, true);
	P.RenderRectangle(Position(19.0,3.0), Position(20.0,18.0), Red, true);
	P.RenderRectangle(Position(3.0,19.0), Position(18.0,20.0), Red, true);

	P.RenderEllipse(Position(2.2,0.7), Position(3.8,2.3), Blue, false);
	P.RenderEllipse(Position(17.2,0.7), Position(18.8,2.3), Blue, false);
	P.RenderEllipse(Position(0.7,2.2), Position(2.3,3.8), Blue, false);
	P.RenderEllipse(Position(0.7,17.2), Position(2.3,18.8), Blue, false);
	P.RenderEllipse(Position(18.7,2.2), Position(20.3,3.8), Blue, false);
	P.RenderEllipse(Position(18.7,17.2), Position(20.3,18.8), Blue, false);
	P.RenderEllipse(Position(2.2,18.7), Position(3.8,20.3), Blue, false);
	P.RenderEllipse(Position(17.2,18.7), Position(18.8,20.3), Blue, false);

	P.RenderEllipse(Position(7.5,7.5), Position(13.5,13.5),White, true);
	P.RenderEllipse(Position(7.6,7.6), Position(13.4,13.4),Magenta, true);		
	P.RenderEllipse(Position(7.7,7.7), Position(13.3,13.3),White, true);
	P.RenderEllipse(Position(8.5,8.5), Position(12.5,12.5),Red, false);
	P.RenderEllipse(Position(8.7,8.7), Position(12.3,12.3),Yellow, true);

	P.RenderLine(Position(10.5,8.7), Position(9.1,11.7), Blue, 0.05);
	P.RenderLine(Position(10.5,8.7), Position(11.9,11.7), Blue, 0.05);
	P.RenderLine(Position(11.9,11.7), Position(8.8,9.8), Blue, 0.05);
	P.RenderLine(Position(8.8,9.8), Position(12.2,9.8), Blue, 0.05);
	P.RenderLine(Position(12.2,9.8), Position(9.1,11.7), Blue, 0.05);

//	Angle();
}

int ApiMain() 
{
	float y,x,a,b;
	P.Open();
	assert(P.GetStatus() == WindowOpen);
	Board();

/*	for(int i=1;i<=100;i++)
	{
		Board();
		P.RenderEllipse(Position(x,x), Position(x+1.5,x+1.5),Cyan, true);
		P.RenderEllipse(Position(x+0.2,x+0.2), Position(x+1.3,x+1.3),White, false);
		P.RenderEllipse(Position(x+0.4,x+0.4), Position(x+1.1,x+1.1),Green, true);	
		x=x+0.1;
		for(int j=0;j<8000000;j++);
	}
*/
/*	while(1)
	{		
		for(float i=0; i<=3.14159265; i+=0.01)
		{
			Board();			
			P.RenderEllipse(Position(3.8+11.9*sin(i),18.75), Position(5.3+11.9*sin(i),20.25),Cyan, true);
			P.RenderEllipse(Position(4.0+11.9*sin(i),18.95), Position(5.1+11.9*sin(i),20.05),White, false);
			P.RenderEllipse(Position(4.2+11.9*sin(i),19.15), Position(4.9+11.9*sin(i),19.85),Green, true);
			for(int j=0;j<8000000;j++);
		}
	}
*/
/*	while(1)
	{
		for(float i=-3.14159265/2; i<=3*3.14159265/2; i+=0.002)
		{
			Board();
			P.RenderEllipse(Position(9.75,18.75), Position(11.25,20.25),Cyan, true);
			P.RenderEllipse(Position(9.95,18.95), Position(11.05,20.05),White, false);
			P.RenderEllipse(Position(10.15,19.15), Position(10.85,19.85),Green, true);
			y=sqrt(25-pow(5*sin(i),2));
			P.RenderLine(Position(10.49,19.45), Position(10.5+5*sin(i),19.5-y), Black, 0.05);
			P.RenderEllipse(Position(10.4+5*sin(i),19.4-y), Position(10.6+5*sin(i),19.6-y),White, true);
			P.RenderEllipse(Position(10.45+5*sin(i),19.45-y), Position(10.55+5*sin(i),19.55-y),Black, true);
			for(int j=0;j<11000000;j++);
		}
	}
*/
	while(1)
	{	
		for(float i=0; i<=3.14159265;i+=0.03)
		{
			Board();
			if(sin(i)<0.36)	P.RenderRectangle(Position(22.0,2.0), Position(22.0+4*(sin(i)),3.0), Magenta , false);
			else if(sin(i)<0.69)	P.RenderRectangle(Position(22.0,2.0), Position(22.0+4*(sin(i)),3.0), Cyan , false);
			else	P.RenderRectangle(Position(22.0,2.0), Position(22.0+4*(sin(i)),3.0), Green , false);
			for(int j=0;j<8500000;j++);
		}
	}

	
/*	cout<<"Enter angle in degrees : ";	cin>>a;	
	if(((int)a/90)%2!=1)
	{
		b = tan(a*3.14159265/180);
		for(x=2.0;x<15.0;x+=0.03)
		{	
			Board();
			y = x*b;
			P.RenderEllipse(Position(x-0.75,y-0.75), Position(x+0.75,y+0.75), Cyan, true);
			P.RenderEllipse(Position(x-0.55,y-0.55), Position(x+0.55,y+0.55), White, false);
			P.RenderEllipse(Position(x-0.35,y-0.35), Position(x+0.35,y+0.35), Green, true);
			for(int j=0;j<8000000;j++);
		}
	}

	else
	{
		for(x=2.0;x<15.0;x+=0.03)
		{
			Board();
			P.RenderEllipse(Position(1.0,x), Position(2.5,x+1.5), Cyan, true);
			P.RenderEllipse(Position(1.2,x+0.2), Position(2.3,x+1.3), White, false);
			P.RenderEllipse(Position(1.4,x+0.4), Position(2.1,x+1.1), Green, true);
			for(int j=0;j<8000000;j++);
		}
		
	}
*/
	return 0;
}

