#include "ezwin.h"
#include <cassert>
#include <cmath>
#include <iostream>
#define pi 3.14159265
SimpleWindow W("Carrom", 28.0, 21.0,Position(0.0, 0.0));
float x,y,z,a,b;
int status=0;
int Input(const Position &P)
{
	x=P.GetXDistance();
	y=P.GetYDistance();
	return 1;
}

void Board()
{
	W.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);	//White Background
//Holes
	W.RenderEllipse(Position(-1.5,-1.5), Position(1.5,1.5), Black, true);
	W.RenderEllipse(Position(-1.5,19.5), Position(1.5,22.5), Black, true);
	W.RenderEllipse(Position(19.5,-1.5), Position(22.5,1.5), Black, true);
	W.RenderEllipse(Position(19.5,19.5), Position(22.5,22.5), Black, true);

	W.RenderRectangle(Position(21.0,0.0), Position(28.5,21.0), White, false);
	W.RenderRectangle(Position(0.0,21.0), Position(25.0,25.0), White, false);
	W.RenderLine(Position(0.0,21.0), Position(21.0,21.0), Black, 0.04);
	W.RenderLine(Position(21.0,0.0), Position(21.0,21.0), Black, 0.04);
//White strips
	W.RenderRectangle(Position(3.0,1.5), Position(18.0,2.5), White, true);	//top
	W.RenderRectangle(Position(1.5,3.0), Position(2.5,18.0), White, true);	//Left
	W.RenderRectangle(Position(18.5,3.0), Position(19.5,18.0), White, true);	//Right
	W.RenderRectangle(Position(3.0,18.5), Position(18.0,19.5), White, true);	//Bottom
//Red Circles
	W.RenderEllipse(Position(2.5,1.5), Position(3.5,2.5), White, true);	//top left
	W.RenderEllipse(Position(2.6,1.6), Position(3.4,2.4), Red, true);	// -- 

	W.RenderEllipse(Position(17.5,1.5), Position(18.5,2.5), White, true);	//top right
	W.RenderEllipse(Position(17.6,1.6), Position(18.4,2.4), Red, true);	// --

	W.RenderEllipse(Position(1.5,2.5), Position(2.5,3.5), White, true);	//Left top
	W.RenderEllipse(Position(1.6,2.6), Position(2.4,3.4), Red, true);	// --

	W.RenderEllipse(Position(1.5,17.5), Position(2.5,18.5), White, true);	//left bottom
	W.RenderEllipse(Position(1.6,17.6), Position(2.4,18.4), Red, true);	// --

	W.RenderEllipse(Position(18.5,2.5), Position(19.5,3.5), White, true);	//right top
	W.RenderEllipse(Position(18.6,2.6), Position(19.4,3.4), Red, true);	// --

	W.RenderEllipse(Position(18.5,17.5), Position(19.5,18.5), White, true);	//right bottom
	W.RenderEllipse(Position(18.6,17.6), Position(19.4,18.4), Red, true);	// --

	W.RenderEllipse(Position(2.5,18.5), Position(3.5,19.5), White, true);	//bottom left
	W.RenderEllipse(Position(2.6,18.6), Position(3.4,19.4), Red, true);	// --

	W.RenderEllipse(Position(17.5,18.5), Position(18.5,19.5), White, true);	//bottom right
	W.RenderEllipse(Position(17.6,18.6), Position(18.4,19.4), Red, true);	// --
//CENTRE
	W.RenderEllipse(Position(7.5,7.5), Position(13.5,13.5),White, true);
	W.RenderEllipse(Position(7.6,7.6), Position(13.4,13.4),Magenta, true);		
	W.RenderEllipse(Position(7.7,7.7), Position(13.3,13.3),White, true);
	W.RenderEllipse(Position(8.5,8.5), Position(12.5,12.5),Red, false);
	W.RenderEllipse(Position(8.7,8.7), Position(12.3,12.3),Yellow, true);
//STAR
	W.RenderLine(Position(10.5,8.7), Position(8.9,11.3), Blue, 0.05);
	W.RenderLine(Position(10.5,8.7), Position(12.1,11.3), Blue, 0.05);
	W.RenderLine(Position(8.9,11.3), Position(12.1,11.3), Blue, 0.05);
	W.RenderLine(Position(8.9,9.7), Position(12.1,9.7), Blue, 0.05);
	W.RenderLine(Position(10.5,12.3), Position(8.9,9.7), Blue, 0.05);
	W.RenderLine(Position(10.5,12.3), Position(12.1,9.7), Blue, 0.05);

	W.RenderEllipse(Position(3.5,3.5), Position(5.5,5.5),White, true);
	W.RenderEllipse(Position(15.5,3.5), Position(17.5,5.5),White, true);
	W.RenderEllipse(Position(3.5,15.5), Position(5.5,17.5),White, true);
	W.RenderEllipse(Position(15.5,15.5), Position(17.5,17.5),White, true);

	W.RenderLine(Position(1.5,1.5), Position(4.5,4.5), Black, 0.05);
	W.RenderLine(Position(19.5,1.5), Position(16.5,4.5), Black, 0.05);
	W.RenderLine(Position(1.5,19.5), Position(4.5,16.5), Black, 0.05);
	W.RenderLine(Position(19.5,19.5), Position(16.5,16.5), Black, 0.05);

//CENTER CIRCLE
	W.RenderEllipse(Position(10,10), Position(11, 11),Green, false);
}


int Queen(const Position& p)
{
	float xcoord=p.GetXDistance();
	float ycoord=p.GetYDistance();
	int d=sqrt(pow((xcoord-10.5),2)+pow((ycoord-10.5),2));
	int Dist[2];
	Dist[0]=sqrt(pow((xcoord-10.7),2)+pow((ycoord-10.5),2));
	Dist[1]=sqrt(pow((xcoord-9.9),2)+pow((ycoord-9.8),2));
	if(d<3.0&&Dist[0]>=1&&Dist[1]>=1)
	{

		if(status==0)
		W.RenderEllipse(Position(xcoord-0.5,ycoord-0.5),Position(xcoord+0.5,ycoord+0.5),Red,true);
		status=1;
		//call the next function
	}
		
	else 
		W.Message("Do it Again ");
	


}


int ApiMain() 
{
	W.Open();
	assert(W.GetStatus() == WindowOpen);
	Board();
	W.RenderEllipse(Position(10.2,10), Position(11.2,11), Yellow, true);
	W.RenderEllipse(Position(9.4,9.3), Position(10.4,10.3), Yellow, true);
	W.SetMouseClickCallback(Queen);
	//W.RenderEllipse(Position(7.8,12), Position(8.8,13), Yellow, true);
	//W.RenderEllipse(Position(12.2,9), Position(13.2,10), Yellow, true);
	//W.RenderEllipse(Position(9.2,11.2), Position(10.2,12.2), Yellow, true);
	//Queen();
return 0;
}
